proc optArithmetic {} {
    global optDestin optXLower optXUpper optXBin optYLower optYUpper optYBin\
	   optCommentTop optCommentX optCommentY optCommentZ\
	   histList ActiveEntry
    set w .optArithmetic
    set d $w.destin
    set s $w.script
    set f $s.functions
    set n $s.numbers
    set b $w.buttons

    if ![winfo exists $w] {
	toplevel $w
	wm title    $w "Polly/Option(Arithmetic)"
	wm iconname $w "Polly/Option(Arithmetic)"

	frame $d -relief groove -bd 2
	frame $s -relief groove -bd 2
	frame $b
	pack  $d $s -fill x -expand 1 -padx 2 -pady 2
	pack  $b

	set dh $d.head
	frame $dh
	label $dh.label -text Destin.:\t -underline 0
	entry $dh.entry -textvariable optDestin -width 18
	button $dh.refer -image imageLEFT -padx 2 -pady 1 -command {
	    set i [.hist.listbox index active]
	    H Option Manipulate Information [expr $i+1]
	    regsub {^ *[0-9]+: *[A-Z0-9!#$&'()+\-\.^_~]+ *[12]D( |\*)(.*)$}\
		    [.hist.listbox get $i] {\2} title
	    set list [split [string trim $title] ";"]
	    set optCommentTop [lindex $list 0]
	    set optCommentX   [lindex $list 1]
	    set optCommentY   [lindex $list 2]
	    set optCommentZ   [lindex $list 3]
	}
	label $dh.lrefer -text Refer -underline 0
	pack  $dh.label $dh.entry -side left -anchor w
	pack  $dh.lrefer $dh.refer -side right -anchor e
	bind $w <Alt-d> "focus $dh.entry"
	bind $w <Alt-r> "$dh.refer invoke"
	foreach i {X Y} {
	    set dw $d.[set j [string tolower $i]]
	    frame $dw
	    label $dw.label  -text "  $i:" -underline 2
	    label $dw.llabel -text " Lower"
	    entry $dw.lentry -textvariable opt${i}Lower -width 10
	    label $dw.ulabel -text " Upper"
	    entry $dw.uentry -textvariable opt${i}Upper -width 10
	    label $dw.blabel -text " Bin"
	    entry $dw.bentry -textvariable opt${i}Bin -width 4
	    pack  $dw.label $dw.llabel $dw.lentry $dw.ulabel $dw.uentry\
			    $dw.blabel $dw.bentry -side left -anchor w
	    bind $w <Alt-$j><Alt-l> "focus $dw.lentry"
	    bind $w <Alt-$j><Alt-u> "focus $dw.uentry"
	    bind $w <Alt-$j><Alt-b> "focus $dw.bentry"
	}
	pack  $dh $d.x $d.y -side top -fill x -expand 1
	label $d.comments -text "  Comments..." -underline 2
	pack  $d.comments -side top -anchor w
	foreach i {Top X Y Z} {
	    set dw $d.comment$i
	    frame $dw
	    pack  $dw -side top -fill x -expand 1
	    label $dw.label -text "    $i:\t"
	    entry $dw.entry -textvariable optComment$i -width 25
	    pack  $dw.label -side left -anchor w
	    pack  $dw.entry -fill x -expand 1
	    bind  $w <Alt-c><Alt-[string range [string tolower $i] 0 0]>\
		    "focus $dw.entry"
	}

	label $s.label -text "Script(s):" -underline 0
	text  $s.text -relief sunken -setgrid 1 -width 25 -height 8\
		-yscrollcommand "$s.scrollbar set"
	scrollbar $s.scrollbar -command "$s.text yview"
	frame $s.spacer -width 1m
	frame $f
	frame $n
	pack  $s.label -side top -anchor w
	pack  $n -side bottom -padx 2m -pady 2 -fill x -expand 1
	pack  $f -side bottom -padx 2m -pady 2 -fill x -expand 1
	pack  $s.spacer -side left
	pack  $s.scrollbar -side right -fill y
	pack  $s.text -side bottom -fill both -expand 1
	bind  $w <Alt-s> "focus $s.text"
	$s.text tag configure color1 -foreground blue1
	$s.text insert end "# Ordinary arithmetic expression,\n#   e.g.  0.5*(H(hist1)+H(hist2))\n# is used to describe hist-manipulation.\n# Multiple statement is available.\n# Coordinate varriables are refered as X, Y.\n" color1
	bind $s.text <FocusIn>\
		"$s.text delete color1.first color1.last;\
                bind $s.text <FocusIn> \"\""

	button $f.clear   -text ClearAll -underline 5 -padx 2 -pady 1\
		-command "$s.text delete 0.0 end"
	button $f.histRef -text HistRef -underline 0 -padx 2 -pady 1\
		-command "$s.text insert insert\
		\"H(\[lindex \$histList \[.hist.listbox index active\]\])\""
	button $f.add -text "+" -padx 1 -pady 1\
		-command "$s.text insert insert +"
	button $f.sub -text "-" -padx 1 -pady 1\
		-command "$s.text insert insert -"
	button $f.mul -text "*" -padx 1 -pady 1\
		-command "$s.text insert insert *"
	button $f.div -text "/" -padx 1 -pady 1\
		-command "$s.text insert insert /"
	button $f.pwr -text "^" -padx 1 -pady 1\
		-command "$s.text insert insert ^"
	button $f.pal -text "(" -padx 1 -pady 1\
		-command "$s.text insert insert ("
	button $f.com -text "," -padx 1 -pady 1\
		-command "$s.text insert insert ,"
	button $f.par -text ")" -padx 1 -pady 1\
		-command "$s.text insert insert )"
	set m $f.func.m
	menubutton $f.func -text Funcs. -underline 0 -menu $m\
		-relief raised -bd 2 -highlightthickness 2 -padx 2 -pady 1
	menu $m -tearoff 0
	foreach i {sqrt exp log sin cos tan asin acos atan atan2\
                min max smooth interp wmean} {
            $m add command -label $i -command "$s.text insert insert ${i}("
        }
	pack $f.clear $f.histRef $f.add $f.sub $f.mul $f.div $f.pwr\
		$f.pal $f.com $f.par $f.func -side left -fill x -expand 1
	button $n.eq  -text "=" -padx 1 -pady 1\
		-command "$s.text insert insert ="
	for {set i 0} {$i < 10} {incr i} {
	    button $n.n$i -text $i -padx 1 -pady 1\
		    -command "$s.text insert insert $i"
	}
	button $n.dot -text "." -padx 1 -pady 1\
		-command "$s.text insert insert ."
	button $n.x  -text "X" -padx 1 -pady 1\
		-command "$s.text insert insert X"
	button $n.y  -text "Y" -padx 1 -pady 1\
		-command "$s.text insert insert Y"
	pack $n.eq $n.n0 $n.n1 $n.n2 $n.n3 $n.n4 $n.n5 $n.n6 $n.n7 $n.n8 $n.n9\
		   $n.dot $n.x $n.y -side left -fill x -expand 1
	bind $s.text <Alt-a> "$f.clear   invoke"
	bind $s.text <Alt-h> "$f.histRef invoke"

	button $b.ok     -text "OK"
	button $b.cancel -text "Cancel"
	pack   $b.ok $b.cancel -side left -padx 4m
	bind $w <Return> "$b.ok     invoke"
	bind $w <Escape> "$b.cancel invoke"

	wm withdraw $w
	update idletasks
	set x [expr [winfo screenwidth  $w]/2 - [winfo reqwidth  $w]/2 \
		- [winfo vrootx [winfo parent $w]]]
	set y [expr [winfo screenheight $w]/2 - [winfo reqheight $w]/2 \
		- [winfo vrooty [winfo parent $w]]]
	wm geom $w +$x+$y
    }
    $b.ok     configure -command\
	    "catch {$s.text delete color1.first color1.last};\
             if \$optYBin\
	     {set title \"'\$optCommentTop\;\$optCommentX\;\$optCommentY\;\$optCommentZ@'\"}\
	     {set title \"'\$optCommentTop\;\$optCommentX\;\$optCommentY@'\"};\
	     if \[CheckNewHist optDestin\]\
	     {set script \"\";\
              for {set i 1.0} {\$i < \[$s.text index end\]}\
                  {set i \[expr \$i+1.0\]}\
              {set script \"\$script\;\[$s.text get \$i \"\$i lineend\"\]\"};\
              H Option Manipulate Arithmetic\
              \[expr \[.hist.listbox index active\]+2\] \$optDestin\
              '\[string range \$script 1 end\]'\
              \$optXLower \$optXUpper \$optXBin\
              \$optYLower \$optYUpper \$optYBin \$title;\
              $b.cancel invoke}\
	     {focus $d.head.entry}"
    $b.cancel configure -command\
	    "focus [focus];\
	     set ActiveEntry .cmdline.entry;\
	     wm withdraw $w"

    set optDestin ""
    set optYBin 0
    $d.head.refer invoke
    set ActiveEntry $d.head.entry
    focus $ActiveEntry
    wm deiconify $w
}
