proc optAssignFunc {} {
    global optSource histList ActiveEntry
    set MaxScript 8
    set w .optAssignFunc
    set t $w.target
    for {set i 1} {$i <= $MaxScript} {incr i} {
	global optAssignScript($i)
	set s($i) $w.script$i
    }
    set f $w.functions
    set n $w.numbers
    set b $w.buttons

    if ![winfo exists $w] {
	toplevel $w
	wm title    $w "Polly/Option(AssignFunc)"
	wm iconname $w "Polly/Option(AssignFunc)"

	frame $t
	pack  $t -side top -fill x -expand 1 -padx 2 -pady 2
	for {set i 1} {$i <= $MaxScript} {incr i}\
		{frame $s($i); pack $s($i) -side top -fill x -expand 1}
	frame $f
	frame $n
	pack  $f $n -fill x -expand 1 -padx 2 -pady 2
	frame $b
	pack  $b

	label $t.label -text Target: -underline 0
	entry $t.entry -textvariable optSource -width 18
	button $t.pickup -image imageLEFT -padx 2 -pady 1 -command {
	    set optSource [lindex $histList [.hist.listbox index active]]
	}
	label $t.lpickup -text Pickup -underline 0
	pack  $t.label $t.entry $t.pickup $t.lpickup -side left -anchor w
	bind $w <Alt-t> "focus $t.entry"
	bind $w <Alt-p> "$t.pickup invoke"

	for {set i 1} {$i <= $MaxScript} {incr i} {
	    label $s($i).label -text "Curve-$i:" -underline 6
	    button $s($i).clear -text "Clear" -underline 0 -padx 2 -pady 1\
		    -command "$s($i).entry delete 0 end"
	    entry  $s($i).entry -width 40 -textvariable optAssignScript($i)
	    pack $s($i).entry -side bottom -fill x -expand 1
	    pack $s($i).label -side left  -anchor w
	    pack $s($i).clear -side right -anchor e
	    bind $s($i).entry <Alt-c> "$s($i).clear invoke"
	    bind $s($i).entry <FocusIn> "set ActiveEntry $s($i).entry"
	    bind $t.entry <Alt-Key-$i> "focus $s($i).entry"
	}
	for {set i 1} {$i <= $MaxScript} {incr i} {
	    for {set j 1} {$j <= $MaxScript} {incr j} {
		if {$i != $j}\
		    {bind $s($i).entry <Alt-Key-$j> "focus $s($j).entry"}
	    }
	}

	button $f.reset   -text ResetAll -underline 0 -padx 2 -pady 1\
		-command "for {set i 1} {\$i <= $MaxScript} {incr i}\
			{set optAssignScript(\$i) \"\"}"
	button $f.add -text "+" -padx 1 -pady 1\
		-command {$ActiveEntry insert insert +}
	button $f.sub -text "-" -padx 1 -pady 1\
		-command {$ActiveEntry insert insert -}
	button $f.mul -text "*" -padx 1 -pady 1\
		-command {$ActiveEntry insert insert *}
	button $f.div -text "/" -padx 1 -pady 1\
		-command {$ActiveEntry insert insert /}
	button $f.pwr -text "^" -padx 1 -pady 1\
		-command {$ActiveEntry insert insert ^}
	button $f.pal -text "(" -padx 1 -pady 1\
		-command {$ActiveEntry insert insert (}
	button $f.com -text "," -padx 1 -pady 1\
		-command {$ActiveEntry insert insert ,}
	button $f.par -text ")" -padx 1 -pady 1\
		-command {$ActiveEntry insert insert )}
	set m $f.func.m
	menubutton $f.func -text Funcs. -underline 0 -menu $m\
		-relief raised -bd 2 -highlightthickness 2 -padx 2 -pady 1
	menu $m -tearoff 0
	foreach i {sqrt exp log sin cos tan asin acos atan atan2\
                min max smooth interp wmean} {
            $m add command -label $i -command "\$ActiveEntry insert insert ${i}("
        }
	pack $f.reset $f.add $f.sub $f.mul $f.div $f.pwr\
		$f.pal $f.com $f.par $f.func -side left -fill x -expand 1
	button $n.eq  -text "=" -padx 1 -pady 1\
		-command {$ActiveEntry insert insert =}
	for {set i 0} {$i < 10} {incr i} {
	    button $n.n$i -text $i -padx 1 -pady 1\
		    -command "\$ActiveEntry insert insert $i"
	}
	button $n.dot -text "." -padx 1 -pady 1\
		-command {$ActiveEntry insert insert .}
	button $n.x  -text "X" -padx 1 -pady 1\
		-command {$ActiveEntry insert insert X}
	pack $n.eq $n.n0 $n.n1 $n.n2 $n.n3 $n.n4 $n.n5 $n.n6 $n.n7 $n.n8 $n.n9\
		   $n.dot $n.x -side left -fill x -expand 1
	for {set i 1} {$i <= $MaxScript} {incr i}\
		{bind $s($i).entry <Alt-r> "$f.reset invoke"}

	button $b.ok     -text OK
	button $b.apply  -text Apply -underline 0
	button $b.cancel -text Cancel
	pack   $b.ok $b.apply $b.cancel -side left -padx 4m
	bind $w <Return> "$b.ok     invoke"
	bind $w <Alt-a>  "$b.apply  invoke"
	bind $w <Escape> "$b.cancel invoke"

	wm withdraw $w
	update idletasks
	set x [expr [winfo screenwidth  $w]/2 - [winfo reqwidth  $w]/2 \
		- [winfo vrootx [winfo parent $w]]]
	set y [expr [winfo screenheight $w]/2 - [winfo reqheight $w]/2 \
		- [winfo vrooty [winfo parent $w]]]
	wm geom $w +$x+$y
    }
    $b.ok     configure -command\
	    "if {\[lsearch \$histList \$optSource\] != -1}\
	         {set script \"\";\
		  for {set i 1} {\$i <= $MaxScript} {incr i}\
		      {if {\$optAssignScript(\$i) != \"\"}\
		        {set script \"\$script '\$optAssignScript(\$i)'\"}};\
		  H Option Assign Function \$optSource \$script;\
		  $b.cancel invoke}\
		 {focus $t.entry}"
    $b.apply  configure -command\
	    "if {\[lsearch \$histList \$optSource\] != -1}\
	         {set script \"\";\
		  for {set i 1} {\$i <= $MaxScript} {incr i}\
		      {if {\$optAssignScript(\$i) != \"\"}\
		        {set script \"\$script '\$optAssignScript(\$i)'\"}};\
		  H Option Assign Function \$optSource \$script}\
		 {focus $t.entry}"
    $b.cancel configure -command\
	    "focus [focus];\
	     set ActiveEntry .cmdline.entry;\
	     wm withdraw $w"

    $t.pickup invoke
    set ActiveEntry $s(1).entry
    focus $ActiveEntry
    wm deiconify $w
}
