set attribVarList {}
foreach i {\
	attribCommentTop attribCommentX attribCommentY attribCommentZ\
	attribXviewLower attribXviewUpper\
	attribYviewLower attribYviewUpper\
	attribZviewLower attribZviewUpper\
	attribAutoScale attribInclude0 attribTicNumber\
	attribDispType attribFactor attribErrorBar attribLog\
	attribGuideEye attribGuideWidth\
	attribIsometric attribRotation attribElevation\
	attribSliceDir attribSliceLower attribSliceUpper\
	attribThres1 attribThres2 attribThres3\
	attribThres4 attribThres5 attribThres6\
    } {trace variable $i w AttribCheckVar}

proc AttribCheckVar {var index action} {
    global attribVarList
    if {[lsearch -exact $attribVarList $var] == -1}\
	    {lappend attribVarList $var}
    .attribute.buttons.apply configure -state normal
    .attribute.buttons.reset configure -state normal
}

proc AttribSendVar apply {
    global  attribID histList attribNDIM attribVarList\
	    attribCommentTop attribCommentX attribCommentY attribCommentZ\
	    attribXviewLower attribXviewUpper attribXBinW\
	    attribYviewLower attribYviewUpper attribYBinW\
	    attribZviewLower attribZviewUpper\
	    attribAutoScale attribInclude0 attribTicNumber\
	    attribDispType attribFactor attribErrorBar attribLog\
	    attribGuideEye attribGuideWidth\
	    attribIsometric attribRotation attribElevation\
	    attribSliceDir attribSliceLower attribSliceUpper\
	    attribThres1 attribThres2 attribThres3\
	    attribThres4 attribThres5 attribThres6

    #-- Chack Numeric Variables
    if {[lsearch $attribVarList attribFactor] != -1} {
	if {[scan [string trim $attribFactor] "%d" f] != 1} {
	    tk_dialog .error "Format Error"\
		    "Input Error \"$attribFactor\"\nin Factor:" error 0 OK
	    focus .attribute.factor.entry
	    return
	}
    }
    if {[lsearch $attribVarList attribThres*] != -1} {
	for {set j 1} {$j <= 6} {incr j} {
	    set cmd "set param \[string trim \$attribThres$j\]"
	    eval $cmd
	    if {[scan $param "%d" x] != 1} {
		tk_dialog .error "Format Error"\
			"Input Error (Threshold:)" warning 0 "OK"
	    focus .attribute.threshold.value.entry$j
	    return
	    }
	}
    }

    #-- Collect Qualifiers
    set Qualifier ""
    if {[lsearch $attribVarList attribXview*] != -1} {
	set Qualifier "$Qualifier/X$attribXviewLower,$attribXviewUpper"
    }
    if {[lsearch $attribVarList attribYview*] != -1} {
	set Qualifier "$Qualifier/Y$attribYviewLower,$attribYviewUpper"
    }
    if {[lsearch -regexp $attribVarList\
	    {attrib(AutoScale|Include0|TicNumber|Zview.*)}] != -1} {
	if $attribAutoScale {
	    set Qualifier "$Qualifier/A1,$attribInclude0,$attribTicNumber"
	} {
	    set Qualifier "$Qualifier/A0,$attribZviewLower,$attribZviewUpper"
	}
    }
    if {[lsearch $attribVarList attribDispType ] != -1 ||\
        [lsearch $attribVarList attribIsometric] != -1} {
	switch $attribNDIM {
	    1 {
		switch $attribDispType {
		    0 {set Qualifier "$Qualifier/M"}
		    1 {set Qualifier "$Qualifier/C"}
		    2 {set Qualifier "$Qualifier/H"}
		}
	    }
	    2 {
		switch $attribDispType {
		    0 {set Qualifier "$Qualifier/I$attribIsometric"}
		    1 {set Qualifier "$Qualifier/C"}
		    2 {set Qualifier "$Qualifier/H"}
		    3 {set Qualifier "$Qualifier/D"}
		}
	    }
	}
    }
    if {[lsearch $attribVarList attribFactor] != -1} {
	set Qualifier "$Qualifier/F$attribFactor"
    }
    if {[lsearch $attribVarList attribErrorBar] != -1} {
	set Qualifier "$Qualifier/B$attribErrorBar"
    }
    if {[lsearch $attribVarList attribLog] != -1} {
	set Qualifier "$Qualifier/L$attribLog"
    }
    if {[lsearch $attribVarList attribGuide*] != -1} {
	set Qualifier "$Qualifier/G$attribGuideEye,$attribGuideWidth"
    }
    if {[lsearch -regexp $attribVarList attrib(Rotation|Elevation)] != -1} {
	set Qualifier "$Qualifier/R$attribRotation,$attribElevation"
    }
    if {[lsearch $attribVarList attribSlice*] != -1} {
	set Qualifier\
	    "$Qualifier/S$attribSliceDir,$attribSliceLower,$attribSliceUpper"
    }
    if {[lsearch $attribVarList attribThres*] != -1} {
	set Qualifier\
	    "$Qualifier/T$attribThres1,$attribThres2,$attribThres3,$attribThres4,$attribThres5,$attribThres6"
    }

    if $apply {
	if {$Qualifier != ""}\
	    {H Attribute " [lindex $histList [expr $attribID-1]]$Qualifier"}
	if {[lsearch $attribVarList attribComment*] != -1} {
	    regsub {'}\
	   "$attribCommentTop;$attribCommentX;$attribCommentY;$attribCommentZ"\
            {''} title
	    H Option Title\
		    [lindex $histList [expr $attribID-1]] "'$title@'"
	}
	set attribVarList {}
	.attribute.buttons.apply configure -state disabled
	.attribute.buttons.reset configure -state disabled
    } {
	H Display " [lindex $histList [expr $attribID-1]]$Qualifier"
    }

    .hist.listbox activate [expr $attribID-1]
    .hist.listbox selection clear 0 end
    .hist.listbox selection set active
    .hist.listbox see active
}

proc attribute fd {
    global  attribID histList attribNDIM attribVarList\
	    attribCommentTop attribCommentX attribCommentY attribCommentZ\
	    attribXviewLower attribXviewUpper attribXBinW\
	    attribYviewLower attribYviewUpper attribYBinW\
	    attribZviewLower attribZviewUpper\
	    attribAutoScale attribInclude0 attribTicNumber\
	    attribDispType attribFactor attribErrorBar attribLog\
	    attribGuideEye attribGuideWidth\
	    attribIsometric attribRotation attribElevation\
	    attribSliceDir attribSliceLower attribSliceUpper\
	    attribThres1 attribThres2 attribThres3\
	    attribThres4 attribThres5 attribThres6

    set w .attribute
    set c $w.comment
    set v $w.view
    set z $w.zscale
    set f $w.factor
    set d $w.display
    set g $w.eyeguide
    set i $w.isometric
    set s $w.slice
    set t $w.threshold
    set b $w.buttons

    if ![winfo exists $w] {

	toplevel $w
	wm iconname $w Polly/Attrib
	label $w.label -text "Attribute of ID:"
	set Black [lindex [$w.label configure -foreground] 3]
	set Color [lindex [$w.label configure -foreground] 4]
	$w.label configure -foreground $Black

	foreach j {c v z f d g i s t b} {set cmd "frame \$$j"; eval $cmd}
	foreach j {top bottom}\
		{frame $w.spacer$j -height 1m; pack  $w.spacer$j -side $j}
	pack $c $v $z $f $d $g $i $s $t $b\
		-side top -fill x -expand 1 -padx 1m -pady 1

        button $b.apply   -text Apply -underline 0\
		-command {AttribSendVar 1}
	button $b.display -text testDisp -underline 4\
		-command {AttribSendVar 0}
        button $b.reset   -text Reset -underline 0\
                -command {H Attribute " [lindex $histList [expr $attribID-1]]"}
        button $b.next    -text Next  -underline 0\
                -command {H Attribute " [lindex $histList $attribID]"}
        button $b.prev    -text Prev  -underline 0\
                -command {H Attribute " [lindex $histList [expr $attribID-2]]"}
        button $b.dismiss -text Dismiss
        pack $b.apply $b.display $b.reset $b.next $b.prev $b.dismiss\
		-side left -fill x -expand 1
	bind $w <Alt-d>  "$b.display invoke"
        bind $w <Alt-a>  "$b.apply   invoke"
        bind $w <Alt-n>  "$b.next    invoke"
        bind $w <Alt-p>  "$b.prev    invoke"
        bind $w <Alt-r>  "$b.reset   invoke"
	bind $w <Escape> "$b.dismiss invoke"

	set m $w.menu
	menu $m -tearoff 0
	$m add command -label "Display"  -command "$b.display invoke"
	$m add command -label "Apply"    -command "$b.apply   invoke"
	$m add command -label "Reset"    -command "$b.reset   invoke"
	$m add command -label "Next"     -command "$b.next    invoke"
	$m add command -label "Previous" -command "$b.prev    invoke"
	$m add command -label "Dismiss"  -command "$b.dismiss invoke"
	bind $w <Button-3> "tk_popup $m \%X \%Y 0"

	label $c.label -text Comments: -underline 0
	pack  $c.label -side top -anchor w
	frame $c.spacer -height 1m
	pack  $c.spacer -side bottom
	foreach j1 {Top X Y Z} {
	    set cw $c.[string tolower $j1]
	    frame $cw
	    pack  $cw -side top -fill x -expand 1 -padx 1m
	    label $cw.label -text "   $j1\t" -fg $Black
	    entry $cw.entry -textvariable attribComment$j1
	    pack  $cw.label -fill y -side left
	    pack  $cw.entry -fill both -expand 1
	    set j2 [string tolower [string index $j1 0]]
	    bind  $w <Alt-c><Any-$j2> "focus $cw.entry"
	}

	foreach j1 {Xview Yview} {
	    set vw $v.[string tolower $j1]
	    frame $vw
	    label $vw.label -text $j1: -underline 0
	    scale $vw.lower -label Lower -orient horizontal -showvalue no\
		    -variable attrib${j1}Lower -command Attrib${j1}Lower
	    proc Attrib${j1}Lower value\
		    "$vw.lower configure -label \"Lower  \$value\""
	    scale $vw.upper -label Upper -orient horizontal -showvalue no\
		    -variable attrib${j1}Upper -command Attrib${j1}Upper
	    proc Attrib${j1}Upper value\
		    "$vw.upper configure -label \"Upper  \$value\""
	    pack  $vw.label -side top -anchor w
	    pack  $vw.lower $vw.upper -side top -fill x -expand 1 -padx 2m
	    set j2 [string tolower [string index $j1 0]]
	    bind $w <Alt-$j2><Any-l> "focus $vw.lower"
	    bind $w <Alt-$j2><Any-u> "focus $vw.upper"
	}
	$v.yview.label configure -text "Yview (2D):"
	pack $v.xview $v.yview -side left -fill both -expand 1

	label $z.label1 -text "Zview:  " -underline 0
	frame $z.spacer -width 2m
	checkbutton $z.autoScale -text AutoScale -variable attribAutoScale
	checkbutton $z.include0  -text Include0 -variable attribInclude0
	label $z.label2 -text " Tic#" -fg $Black
	scale $z.ticNumber -orient horizontal -from 2 -to 14 -showvalue no\
		-variable attribTicNumber -command AttribTicNumber
	label $z.label3 -text " 8" -fg $Black
	proc AttribTicNumber value "$z.label3 configure -text \" \$value\""
	frame $z.view
	pack $z.label1 -side top -anchor w
	pack $z.view -side bottom -fill x
	pack $z.spacer $z.autoScale $z.include0 $z.label2\
		$z.ticNumber $z.label3 -side left
	scale $z.view.lower -label Lower -orient horizontal -showvalue no\
		-variable attribZviewLower -command AttribZviewLower
	proc AttribZviewLower value\
		"$z.view.lower configure -label \"Lower  \$value\""
	scale $z.view.upper -label Upper -orient horizontal -showvalue no\
		-variable attribZviewUpper -command AttribZviewUpper
	proc AttribZviewUpper value\
		"$z.view.upper configure -label \"Upper  \$value\""
	pack $z.view.lower $z.view.upper -side left -fill x -expand 1 -padx 2m
	bind $w  <Alt-z> "focus $z.autoScale"
	set za $z.autoScale
	bind $za <Any-i> "focus $z.include0"
	bind $za <Any-t> "focus $z.ticNumber"
	bind $za <Any-l> "focus $z.view.lower"
	bind $za <Any-u> "focus $z.view.upper"

	label $d.label1 -text "DispKind: " -underline 4
	menubutton $d.type -text Histogram -relief sunken\
		-bd 2 -highlightthickness 2
	label $d.label2 -text " Mode: " -underline 1
	menubutton $d.mode -text Trial -relief sunken\
		-bd 2 -highlightthickness 2 -menu $d.mode.menu
	checkbutton $d.errorBar -text ErrorBar -underline 0\
		-variable attribErrorBar -fg $Color
	pack $d.label1 $d.type $d.label2 $d.mode -side left -anchor w
	place $d.errorBar -anchor w -relx 0.75 -rely 0.5
	bind $w <Alt-k> "tkMbPost $d.type"
	bind $w <Alt-m> "tkMbPost $d.mode"
	bind $w <Alt-e> "focus $d.errorBar; $d.errorBar invoke"

	menu $d.type.menu1 -tearoff 0
	set ord 0
	foreach j {Marker Line Histogram} {
	    $d.type.menu1 add command -label $j -underline 0\
		-command "$d.type configure -text $j; set attribDispType $ord"
	    incr ord
	}
	menu $d.type.menu2 -tearoff 0
	set ord 0
	foreach j {Isometric Contour Histogram Dot} {
	    $d.type.menu2 add command -label $j -underline 0\
		-command "$d.type configure -text $j; set attribDispType $ord"
	    incr ord
	}
	menu $d.mode.menu -tearoff 0
	foreach j {Ratio Success Failure Trials} {
	    $d.mode.menu add command -label $j -underline 0\
		    -command "$d.mode configure -text $j"
	}

	label $f.label -text "Factor:   " -underline 0
	entry $f.entry -textvariable attribFactor -width 15
	frame $f.spacer -width 40
	radiobutton $f.linear -text Linear -underline 0 -fg $Color\
		-variable attribLog -value 0\
		-command "bind $w <Alt-l> \"focus $f.log   ;$f.log    invoke\""
	radiobutton $f.log    -text Log    -underline 0 -fg $Color\
		-variable attribLog -value 1\
		-command "bind $w <Alt-l> \"focus $f.linear;$f.linear invoke\""
	pack $f.label $f.entry $f.spacer $f.linear $f.log -side left -anchor w
	bind $w <Alt-f> "focus $f.entry"

	label $g.label1 -text GuideEye: -underline 0
	checkbutton $g.guideEye -variable attribGuideEye
	label $g.label2 -text "BinWidth (0.0)" -underline 3 -fg $Black
	scale $g.binWidth -orient horizontal -length 100 -from 1 -to 9\
		-variable attribGuideWidth -resolution 0.5 -showvalue no\
		-command AttribGuideWidth
	proc AttribGuideWidth value\
		"$g.label2 configure -text \"BinWidth (\$value)\""
	pack $g.label1 $g.guideEye $g.label2 $g.binWidth\
		-side left -anchor w
	bind $w <Alt-g>          "focus $g.guideEye"
	bind $g.guideEye <Any-w> "focus $g.binWidth"

	label $i.label -text "Isometric (2D):  " -underline 0
        set im $i.mode.menu
        menubutton $i.mode -text 0:LINE_along_X -menu $im -relief sunken\
                -bd 2 -highlightthickness 2
        menu $im -tearoff 0
	foreach j {0:LINE_along_X 1:LINE_along_Y\
		   2:MESH_along_X 3:MESH_along_Y\
		   4:HIST_along_X 5:HIST_along_Y\
		   6:LEGO_along_X 7:LEGO_along_Y} {
	       $im add command -label $j -underline 0\
		       -command "$i.mode configure -text $j;\
		       set attribIsometric [string index $j 0]"
	}
	set ia $i.angles
        frame $ia
	scale $i.angles.rotation  -label Rotation  -orient horizontal\
		-from -180 -to 180 -resolution 5 -showvalue no\
		-variable attribRotation\
		-command AttribRotation
	proc AttribRotation value\
                "$ia.rotation configure -label \"Rotation  \$value deg\""
	scale $i.angles.elevation -label Elevation -orient horizontal\
		-from -180 -to 180 -resolution 5  -showvalue no\
		-variable attribElevation\
		-command AttribElevation
	proc AttribElevation value\
                "$ia.elevation configure -label \"Elevation  \$value deg\""
        pack $ia -side bottom -fill x -expand 1
	pack $i.label $i.mode -side left -anchor w
	pack $ia.rotation $ia.elevation -side left -fill x -expand 1 -padx 3m
        bind $w      <Alt-i> "focus $i.mode"
	bind $i.mode <Any-r> "focus $ia.rotation"
	bind $i.mode <Any-e> "focus $ia.elevation"

	label $s.label -text "Slice (2D):  " -underline 0
	frame $s.limit
	set sm $s.mode.menu
	menubutton $s.mode -text onto_X -menu $sm -relief sunken\
		-bd 2 -highlightthickness 2
	menu  $sm -tearoff 0
	$sm add command -label onto_X -underline 5 -command "\
                $s.mode configure -text onto_X;\
                set attribSliceDir 0;\
                $s.limit.lower configure -resolution \$attribYBinW\
                    -from \$attribYviewLower -to \$attribYviewUpper;\
                $s.limit.upper configure -resolution \$attribYBinW\
                    -from \$attribYviewLower -to \$attribYviewUpper"
	$sm add command -label onto_Y -underline 5 -command "\
                $s.mode configure -text onto_Y;\
                set attribSliceDir 1;\
                $s.limit.lower configure -resolution \$attribXBinW\
                    -from \$attribXviewLower -to \$attribXviewUpper;\
                $s.limit.upper configure -resolution \$attribXBinW\
                    -from \$attribXviewLower -to \$attribXviewUpper"
	pack  $s.limit -side bottom -fill x
	pack  $s.label $s.mode -side left -anchor w
	scale $s.limit.lower -label Lower -orient horizontal -showvalue no\
		-variable attribSliceLower -command AttribSliceLower
	proc AttribSliceLower value\
		"$s.limit.lower configure -label \"Lower  \$value\""
	scale $s.limit.upper -label Upper -orient horizontal -showvalue no\
		-variable attribSliceUpper -command AttribSliceUpper
	proc AttribSliceUpper value\
		"$s.limit.upper configure -label \"Upper  \$value\""
	pack  $s.limit.lower $s.limit.upper\
		-side left -fill x -expand 1 -padx 3m
	bind $w      <Alt-s> "focus $s.mode"
	bind $s.mode <Any-l> "focus $s.limit.lower"
	bind $s.mode <Any-u> "focus $s.limit.upper"

	label $t.label -text "Threshold (2D):" -underline 0
	set tv $t.value
	frame $tv
	pack  $tv -side bottom -fill x -expand 1 -padx 3m
	pack  $t.label -side left -anchor w
	for {set j 1} {$j <= 6} {incr j} {
	    label $tv.label$j -text $j -fg $Black
	    entry $tv.entry$j -width 4 -textvariable attribThres$j
	    pack $tv.label$j $tv.entry$j -side left -expand 1
	}
	bind $w <Alt-t> "focus $tv.entry1"

	foreach j "$c $v.xview $v.yview $z $i $s $t"\
		{$j configure -relief groove -borderwidth 3}

	wm withdraw $w
	update idletasks
	set x [expr [winfo screenwidth  $w]/2 - [winfo reqwidth  $w]/2 \
		- [winfo vrootx [winfo parent $w]]]
	set y [expr [winfo screenheight $w]/2 - [winfo reqheight $w]/2 \
		- [winfo vrooty [winfo parent $w]]]
	wm geom $w +$x+$y
    }

    if {[gets $fd line] != -1} {
        scan $line " %d" attribID
	if {$attribID == 1}\
		"$b.prev configure -state disabled"\
		"$b.prev configure -state normal"
	if {$attribID == [llength $histList]}\
		"$b.next configure -state disabled"\
		"$b.next configure -state normal"
	wm title $w\
		"Polly \"$attribID: [lindex $histList [expr $attribID-1]]\""
        .hist.listbox activate [expr $attribID-1]
        .hist.listbox selection clear 0 end
        .hist.listbox selection set active
        .hist.listbox see active
    }
    while {[gets $fd line] != -1} {
        switch $line {
            "<< TITLE >>" {
                if {[gets $fd param] == -1} break
                set list [split [string range $param 0\
                        [expr [string first "@" $param]-1]] ";"]
                set attribCommentTop [lindex $list 0]
                set attribCommentX   [lindex $list 1]
                set attribCommentY   [lindex $list 2]
                set attribCommentZ   [lindex $list 3]
            }
            "<< NDIM >>" {
                if {[gets $fd param] == -1} break
                scan $param "%d" attribNDIM
                if {$attribNDIM != 2} {
                    set state disabled
                    $d.type configure -menu $d.type.menu1
                } {
                    set state normal
                    $d.type configure -menu $d.type.menu2
                }
                foreach j "$c.z.entry $v.yview.lower $v.yview.upper\
                        $i.mode $i.angles.rotation $i.angles.elevation\
                        $s.mode $s.limit.lower $s.limit.upper\
			$t.value.entry1 $t.value.entry2 $t.value.entry3\
			$t.value.entry4 $t.value.entry5 $t.value.entry6" {
                    $j configure -state $state
                }
            }
            "<< MS >>" {
                if {[gets $fd param] == -1} break
                scan $param "%3s" attribMS
                if {[lsearch -exact\
                        {A*4 EFF EF2 EF1 ASM AS2 AS1} $attribMS] == -1} {
                    $d.mode configure -state disabled
                } {
                    $d.mode configure -state normal
                }
            }
            "<< XBIN >>" {
                if {[gets $fd param] == -1} break
                scan $param " %f %f %f" from to attribXBinW
                foreach j {lower upper} {$v.xview.$j configure\
                            -from $from -to $to -resolution $attribXBinW}
            }
            "<< XVIEW >>" {
                if {[gets $fd param] == -1} break
                scan $param " %f %f" attribXviewLower attribXviewUpper
		$v.xview.lower configure -label "Lower  $attribXviewLower"
		$v.xview.upper configure -label "Upper  $attribXviewUpper"
            }
            "<< YBIN >>" {
                if {[gets $fd param] == -1} break
                scan $param " %f %f %f" from to attribYBinW
                foreach j {lower upper} {$v.yview.$j configure\
                            -from $from -to $to -resolution $attribYBinW}
            }
            "<< YVIEW >>" {
                if {[gets $fd param] == -1} break
                scan $param " %f %f" attribYviewLower attribYviewUpper
		$v.yview.lower configure -label "Lower  $attribYviewLower"
		$v.yview.upper configure -label "Upper  $attribYviewUpper"
            }
            "<< ZAUTO >>" {
                if {[gets $fd param] == -1} break
                scan $param " %d" attribAutoScale
            }
            "<< ZZERO >>" {
                if {[gets $fd param] == -1} break
                scan $param " %d" attribInclude0
            }
            "<< YTIC >>" {
                if {[gets $fd param] == -1} break
                scan $param " %d" attribTicNumber
                $z.label3 configure -text " $attribTicNumber"
            }
            "<< ZTIC >>" {
                if {[gets $fd param] == -1} break
                scan $param " %d" attribTicNumber
                $z.label3 configure -text " $attribTicNumber"
            }
            "<< ZVIEW >>" {
                if {[gets $fd param] == -1} break
                scan $param " %f %f %f" from to resolution
		foreach j {lower upper} {
		    $z.view.$j configure\
			    -from $from -to $to -resolution $resolution
		}
                set attribZviewLower $from
                set attribZviewUpper $to
		$z.view.lower configure -label "Lower  $attribZviewLower"
		$z.view.upper configure -label "Upper  $attribZviewUpper"
            }
            "<< ERROR >>" {
                if {[gets $fd param] == -1} break
                scan $param " %d" attribErrorBar
            }
            "<< ZLOG >>" {
                if {[gets $fd param] == -1} break
                scan $param " %d" attribLog
		if $attribLog {
		    bind $w <Alt-l> "focus $f.linear;$f.linear invoke"
		} {
		    bind $w <Alt-l> "focus $f.log   ;$f.log    invoke"
		}
            }
            "<< FACTOR >>" {
                if {[gets $fd param] == -1} break
                scan $param " %f" attribFactor
            }
            "<< LINE >>" {
                if {[gets $fd param] == -1} break
                scan $param " %d" attribDispType
                if {$attribNDIM != 2} {
                    $d.type configure -text\
			    [$d.type.menu1 entrycget $attribDispType -label]
                } {
                    $d.type configure -text\
			    [$d.type.menu2 entrycget $attribDispType -label]
                }
            }
            "<< YALT >>" {
                if {[gets $fd param] == -1} break
                scan $param " %d" yalt
                $d.mode configure -text [$d.mode.menu entrycget $yalt -label]
            }
            "<< SMOOTH >>" {
                if {[gets $fd param] == -1} break
                scan $param " %d" attribGuideEye
            }
            "<< WSMOOTH >>" {
                if {[gets $fd param] == -1} break
                scan $param " %f" attribGuideWidth
		$g.label2 configure -text\
			"BinWidth ([format {%3.1f} $attribGuideWidth])"
            }
            "<< 2DLINE >>" {
                if {[gets $fd param] == -1} break
                scan $param " %d" attribIsometric
                $i.mode configure -text\
			[$i.mode.menu entrycget $attribIsometric -label]
            }
            "<< ROTATION >>" {
                if {[gets $fd param] == -1} break
                scan $param " %d %d" attribRotation attribElevation
                $i.angles.rotation configure\
			-label "Rotation  $attribRotation deg"
                $i.angles.elevation configure\
			-label "Elevation  $attribElevation deg"
            }
            "<< SLDIR >>" {
                if {[gets $fd param] == -1} break
                scan $param " %d" attribSliceDir
                $s.mode configure\
                        -text [$s.mode.menu entrycget $attribSliceDir -label]
                if {$attribSliceDir} {
                    $s.limit.lower configure -resolution $attribXBinW\
                            -from $attribXviewLower -to $attribXviewUpper
                    $s.limit.upper configure -resolution $attribXBinW\
                            -from $attribXviewLower -to $attribXviewUpper
                } {
                    $s.limit.lower configure -resolution $attribYBinW\
                            -from $attribYviewLower -to $attribYviewUpper
                    $s.limit.upper configure -resolution $attribYBinW\
                            -from $attribYviewLower -to $attribYviewUpper
                }
            }
            "<< SLBEG >>" {
                if {[gets $fd param] == -1} break
                scan $param " %d" SlBeg
                if {$attribSliceDir} {
                    set attribSliceLower\
                            [expr $attribXviewLower+($SlBeg-1)*$attribXBinW]
                } {
                    set attribSliceLower\
                            [expr $attribYviewLower+($SlBeg-1)*$attribYBinW]
                }
                $s.limit.lower configure -label "Lower  $attribSliceLower"
            }
            "<< SLWIDTH >>" {
                if {[gets $fd param] == -1} break
                scan $param " %d" SlWid
                if {$attribSliceDir} {
                    set attribSliceUpper\
                            [expr $attribSliceLower+$SlWid*$attribXBinW]
                } {
                    set attribSliceUpper\
                            [expr $attribSliceLower+$SlWid*$attribYBinW]
                }
                $s.limit.upper configure -label "Upper  $attribSliceUpper"
            }
            "<< THRESHOLD >>" {
                if {[gets $fd param] == -1} break
                scan $param " %d %d %d %d %d %d"\
                        attribThres1 attribThres2 attribThres3\
                        attribThres4 attribThres5 attribThres6
            }
            "<< EOF >>" {
                break
            }
        }
    }
    set attribVarList {}
    $b.apply   configure -state disabled
    $b.reset   configure -state disabled
    $b.dismiss configure -command "focus [focus]; wm withdraw $w"
    wm deiconify $w
    raise $w .
    focus $w
}
