proc cursorFileWrite {} {
    global cursorList cursorHist cursorTarget ActiveEntry
    set w .cursorWrite
    set c $w.cursors
    set h $w.hist
    set f $w.file
    set b $w.buttons
    if ![winfo exists $w] {
	toplevel $w
	wm title $w "Polly/CursorWrite"
	wm iconname $w "Polly/CursorWrite"

	frame $c
	set cn $c.num
	frame $cn
	for {set i 1} {$i <= 8} {incr i} {
	    set cursorList($i) 1
	    button $cn.c$i -text $i -underline 0\
		    -padx 2 -pady 1 -relief sunken -command\
		"if \$cursorList($i)\
		{$cn.c$i configure -relief raised}\
		{$cn.c$i configure -relief sunken};\
		set cursorList($i) \[expr 1-\$cursorList($i)\]"
	    pack $cn.c$i -side left
	    bind $w <Alt-Key-$i> "$cn.c$i invoke"
	}
	pack  $cn -side bottom
	label $c.label -text Cursor:
	pack  $c.label -side left -anchor w
	button $c.allset -text AllSet -underline 3 -padx 1 -pady 0 -command "\
		for {set i 1} {\$i <= 8} {incr i}\
		{set cursorLiet(\$i) 1; $cn.c\$i configure -relief sunken}"
	button $c.reset  -text Reset -underline 0 -padx 1 -pady 0 -command "\
		for {set i 1} {\$i <= 8} {incr i}\
		{set cursorLiet(\$i) 0; $cn.c\$i configure -relief raised}"
	pack  $c.reset $c.allset -side right -anchor e
	bind  $w <Alt-s> "$c.allset invoke"
	bind  $w <Alt-r> "$c.reset  invoke"

	frame $h
	label $h.label -text Hist: -underline 0
	entry $h.entry -width 30 -textvariable cursorHist
	button $h.pickup -text Pickup -underline 0 -padx 1 -pady 0 -command "\
		if {\$cursorHist == \"*\"} {set cursorHist \"\"};\
		$h.entry insert insert\
		  \" \[lindex \$histList \[.hist.listbox index active\]\]\";\
		tkListboxUpDown .hist.listbox 1"
        pack  $h.entry -side bottom -fill x -padx 2m
        pack  $h.label -side left -anchor w
	pack  $h.pickup -side right -anchor e
	bind  $w <Alt-h> "focus $h.entry"
	bind  $w <Alt-p> "$h.pickup invoke"
	set  q $h.entry
	set  l .hist.listbox
	bind $q <KP_Enter>  "$h.pickup invoke"
	bind $q <Up>        "tkListboxUpDown $l -1"
	bind $q <Down>      "tkListboxUpDown $l  1"
	bind $q <Control-p> "tkListboxUpDown $l -1"
	bind $q <Control-n> "tkListboxUpDown $l  1"
	bind $q <Shift-Up>  "tkListboxExtendUpDown $l -1"
	bind $q <Shift-Down> "tkListboxExtendUpDown $l  1"
	bind $q <Alt-less>  {histListboxSelect "0" ""}
	bind $q <Alt-greater> {histListboxSelect "end" ""}
	bind $q <Prior>     {histListboxSelect "@0,0" "yview scroll -1 pages"}
	bind $q <Next>      {histListboxSelect "@0,0" "yview scroll  1 pages"}
	bind $q <Alt-v>     {histListboxSelect "@0,0" "yview scroll -1 pages"}
	bind $q <Control-v> {histListboxSelect "@0,0" "yview scroll  1 pages"}

	frame $f
	label $f.label -text File: -underline 0
	entry $f.entry -width 30 -textvariable cursorTarget
	button $f.browse -text Browse -underline 0 -padx 1 -pady 0 -command {
	    genFile .writeCursor "Polly/CursorWrite"\
		    cursorMask cursorTemp 0 CursorWriteSet 1
	}
	proc CursorWriteSet target\
		{global cursorTarget; set cursorTarget $target }
        pack  $f.entry  -side bottom -fill x -padx 2m
	pack  $f.label  -side left -anchor w
	pack  $f.browse -side right -anchor e
	bind  $w <Alt-f> "focus $f.entry"
	bind  $w <Alt-b> "$f.browse invoke"

	frame $b
	button $b.ok     -text Ok -command "\
		set c \"\";\
		for {set i 1} {\$i <=8} {incr i}\
		  {if \$cursorList(\$i) {set c \"\$c,\$i\"}};\
		H Cursor Write\
		  \$cursorTarget \[string range \$c 1 end\] \$cursorHist;\
		$b.cancel invoke"
	button $b.cancel -text Cancel
	pack  $b.ok $b.cancel -side left -padx 2m
	bind  $w <Return> "$b.ok     invoke"
	bind  $w <Escape> "$b.cancel invoke"

	pack  $c $h $f -side top -fill x -expand 1 -padx 1m -pady 2
	pack  $b -pady 1m

	wm withdraw $w
        update idletasks
        set x [expr [winfo screenwidth  $w]/2 - [winfo reqwidth  $w]/2 \
                - [winfo vrootx [winfo parent $w]]]
        set y [expr [winfo screenheight $w]/2 - [winfo reqheight $w]/2 \
                - [winfo vrooty [winfo parent $w]]]
        wm geom $w +$x+$y
    }
    $b.cancel configure -command\
	    "set ActiveEntry $ActiveEntry; focus [focus]; wm withdraw $w"
    set cursorHist *
    set ActiveEntry $h.entry
    wm deiconify $w
    focus $f.entry
}
