set root .menu.edit.m

set w $root.wildCard
menu  $w -tearoff 0 -postcommand {set histSelectWcard ""}
label $w.label -text "Pattern:"
entry $w.entry -textvariable histSelectWcard -width 30
pack  $w.label $w.entry -side left -padx 4 -pady 3m
bind  $w <FocusIn> "focus $w.entry"
bind  $w.entry <Return> "tkMenuEscape [winfo parent $w]
			if {\$histSelectWcard != \"\"}\
	                   {histSelectAction \"\$histSelectWcard\"}
			focus \$ActiveEntry"
bind  $w.entry <Escape> "tkMenuEscape $w; set histSelectWcard \"\""
bind  $w.entry <Left> "if {\$histSelectWcard == \"\"} {tkMenuEscape $w}"

#----------------------------------------------------------

set m $root.pastePosition
menu $m -tearoff 0
$m add command -label "Before..." -underline 0\
        -command {if [checkCmdline] {H Edit Paste $cmdline/B; set cmdline ""}}
$m add command -label "After..." -underline 0\
        -command {if [checkCmdline] {H Edit Paste $cmdline/A; set cmdline ""}}

#----------------------------------------------------------

proc EditAction {action c} {
    global editName1 editName2 histList ActiveEntry
    set w .editAction
    set b $w.buttons
    if ![winfo exists $w] {
        set l .hist.listbox
	frame  $w -relief raised -bd 2
	label $w.label -text $action
	pack  $w.label -side top -anchor w
	foreach i {1 2} {
	    frame $w.[set j name$i]
	    pack  $w.$j -side top -fill x -expand 1 -padx 1m
	    label $w.$j.label -text "$i:"
	    entry $w.$j.entry -textvariable editName$i -width 16
	    pack  $w.$j.label $w.$j.entry -side left
	    bind  $w.$j.entry <Return> "$b.ok     invoke"
	    bind  $w.$j.entry <Escape> "$b.cancel invoke"
	}
	frame  $b
	pack   $b -side bottom -pady 1m
	button $b.ok     -text OK     -padx 2 -pady 2
	button $b.cancel -text Cancel -padx 2 -pady 2
	pack   $b.ok $b.cancel -side left -padx 3m
	set  f $w.name1
	button $f.button -image imageLEFT -padx 1 -pady 1 -command "\
                set editName1 \[lindex \$histList \[$l index active\]\];\
                focus $w.name2.entry"
	pack  $f.button -side left
        set e $f.entry
        bind  $e <KP_Enter>  "$f.button invoke"
	bind  $e <Up>        "tkListboxUpDown $l -1"
	bind  $e <Down>      "tkListboxUpDown $l  1"
	bind  $e <Control-p> "tkListboxUpDown $l -1"
	bind  $e <Control-n> "tkListboxUpDown $l  1"
	bind  $e <Shift-Up>  "tkListboxExtendUpDown $l -1"
	bind  $e <Shift-Down> "tkListboxExtendUpDown $l  1"
	bind  $e <Alt-less>  {histListboxSelect "0" ""}
	bind  $e <Alt-greater> {histListboxSelect "end" ""}
	bind  $e <Prior>     {histListboxSelect "@0,0" "yview scroll -1 pages"}
	bind  $e <Next>      {histListboxSelect "@0,0" "yview scroll  1 pages"}
	bind  $e <Alt-v>     {histListboxSelect "@0,0" "yview scroll -1 pages"}
	bind  $e <Control-v> {histListboxSelect "@0,0" "yview scroll  1 pages"}
    }
    $w.name1.button invoke
    set editName2 ""
    $b.ok     configure -command "\
            if \[CheckNewHist editName2\] {\
            place forget $w; focus [focus]; set ActiveEntry $ActiveEntry;\
            H Edit $action \"\$editName1\" \"\$editName2\"}"
    $b.cancel configure -command "\
            place forget $w; focus [focus]; set ActiveEntry $ActiveEntry"
    set m [winfo parent $c]
    place $w -x [expr [winfo x $m]+[winfo x $c]]\
	     -y [expr [winfo y $m]+[winfo y $c]+[winfo height $m]]
    set ActiveEntry $w.name1.entry
    focus $ActiveEntry
}

proc CheckNewHist name0 {
    upvar $name0 name
    global histList
    set name [string toupper [string trim $name]]
    if {$name == ""} {
        tk_dialog .error "Empty Name" "Empty Histogram Name" error 0 OK
        return 0
    }
    if ![regexp {^[A-Z!#^_~]+[A-Z0-9!#$&'()+\-\.^_~]*$} $name] {
        tk_dialog .error "Illigal Name"\
                "Illigal Histogram Name \"$name\"" error 0 OK
        return 0
    }
    if {[lsearch $histList $name] != -1} {
        tk_dialog .error "Duplicate Name"\
                "Duplicate Histogram Name \"$name\"" error 0 OK
        return 0
    }
    return 1
}

#----------------------------------------------------------

menu [set w $root.title] -tearoff 0 -postcommand {set EditTitle $histTitle}
pack [entry [set e $w.entry] -textvariable EditTitle -width 40]\
        -padx 2m -pady 3m
bind $w <FocusIn> "focus $e"
bind $e <Return> "tkMenuEscape [winfo parent $w]
		regsub {'} \$EditTitle {''} sendTitle
		H Edit Title '\$sendTitle'
		focus \$ActiveEntry"
bind $e <Escape> "tkMenuEscape $w"
