set root .menu.graphics.m

array set OrdName {
    1 "1-st"
    2 "2-nd"
    3 "3-rd"
    4 "4-th"
    5 "5-th"
    6 "6-th"
    7 "7-th"
    8 "8-th"
}
set ColorList  {White Red Green Blue Yellow Magenta Cyan}

#-- Over-Plot Color

set HpkGraphicsOverColor(1) CYAN
set HpkGraphicsOverColor(2) RED
set HpkGraphicsOverColor(3) GREEN
set HpkGraphicsOverColor(4) YELLOW
set HpkGraphicsOverColor(5) MAGENTA
set HpkGraphicsOverColor(6) WHITE
set HpkGraphicsOverColor(7) BLUE
set HpkGraphicsOverColor(8) CYAN
trace variable HpkGraphicsOverColor w putGraphicsVar

set w .overColor
frame $w -relief raised -bd 2
label $w.label -text "OverPlot Colors"
button $w.dismiss -text Dismiss
pack $w.label -side top -anchor w -padx 3 -pady 3
pack $w.dismiss -side bottom -pady 3
set n [array size HpkGraphicsOverColor]
for {set i 1} {$i <= $n} {incr i} {
    set b $w.color$i ; set m $b.m
    menubutton $b -text $OrdName($i) -menu $m\
            -relief raised -bd 2 -highlightthickness 2
    pack $b -side left -padx 2
    if {$i !=  1} {bind $b <Left>  "focus $w.color[expr $i-1]"}
    if {$i != $n} {bind $b <Right> "focus $w.color[expr $i+1]"}
    bind $b <Enter>  "focus $b"
    bind $b <Down>   "tkMbPost $b; tkMenuFirstEntry $m"
    bind $b <Escape> "$w.dismiss invoke"
    bind $b <KeyPress> "if \[regexp {\[1-$n\]+} \%A\]\
	    {tkMbPost $w.color\%A ; tkMenuFirstEntry $w.color\%A.m}"
    menu $m -tearoff 0
    foreach color $ColorList {
        $m add radiobutton -label $color -underline 0\
		-activebackground $color\
		-variable HpkGraphicsOverColor($i)\
                -value [string toupper $color]\
                -command "$b configure -background $color"
    }
    bind $m <Unmap> "focus $b"
}
bind $w.color1  <Left>  "focus $w.color$n"
bind $w.color$n <Right> "focus $w.color1"
proc reconfigOverColor {w b} {
    global HpkGraphicsOverColor
    for {set i 1} {$i <= [array size HpkGraphicsOverColor]} {incr i} {
	$w.color$i configure -background $HpkGraphicsOverColor($i)
    }
    set m [winfo parent $b]
#   place $w -x [expr [winfo x $m]+[winfo x $b]]
    place $w -x [winfo x $m]\
             -y [expr [winfo y $m]+[winfo y $b]+[winfo height $m]]
    $w.dismiss configure -command "place forget $w; focus [focus]"
    focus $w.color1
}

#-- Over-Plot Line Type

set HpkGraphicsOverLine(1) SOLID
set HpkGraphicsOverLine(2) BROKEN
set HpkGraphicsOverLine(3) DOTTED
set HpkGraphicsOverLine(4) CHAIN
set HpkGraphicsOverLine(5) SOLID
set HpkGraphicsOverLine(6) BROKEN
set HpkGraphicsOverLine(7) DOTTED
set HpkGraphicsOverLine(8) CHAIN
trace variable HpkGraphicsOverLine w putGraphicsVar

set w .overLine
frame $w -relief raised -bd 2
label $w.label -text "OverPlot Line Types"
button $w.dismiss -text Dismiss
pack $w.label -side top -anchor w -padx 3 -pady 3
pack $w.dismiss -side bottom -pady 3
set n [array size HpkGraphicsOverLine]
for {set i 1} {$i <= $n} {incr i} {
    set b $w.line$i ; set m $b.m
    menubutton $b -menu $m -text "$OrdName($i)\nb"\
	    -relief raised -bd 2 -highlightthickness 2
    pack $b -side left -padx 2
    label $b.label -text $OrdName($i)
    label $b.image
    pack $b.label $b.image -in $b
    if {$i !=  1} {bind $b <Left>  "focus $w.line[expr $i-1]"}
    if {$i != $n} {bind $b <Right> "focus $w.line[expr $i+1]"}
    bind $b <Enter>  "focus $b"
    bind $b <Down>   "tkMbPost $b; tkMenuFirstEntry $m"
    bind $b.label <Button-1> "tkMbPost $b; tkMenuFirstEntry $m"
    bind $b.image <Button-1> "tkMbPost $b; tkMenuFirstEntry $m"
    bind $b <Escape> "$w.dismiss invoke"
    bind $b <KeyPress> "if \[regexp {\[1-$n\]+} \%A\]\
	    {tkMbPost $w.line\%A ; tkMenuFirstEntry $w.line\%A.m}"
    menu $m -tearoff 0
    foreach line {Solid Broken Dotted Chain} {
        $m add radiobutton -label $line -underline 0\
		-variable HpkGraphicsOverLine($i)\
                -value [string toupper $line]\
                -command\
                 "$b.image configure -image image[string toupper $line]"
    }
    bind $m <Unmap> "focus $b"
}
bind $w.line1  <Left>  "focus $w.line$n"
bind $w.line$n <Right> "focus $w.line1"
proc reconfigOverLine {w b} {
    global HpkGraphicsOverLine
    for {set i 1} {$i <= [array size HpkGraphicsOverLine]} {incr i} {
	$w.line$i.image configure -image image$HpkGraphicsOverLine($i)
    }
    set m [winfo parent $b]
#   place $w -x [expr [winfo x $m]+[winfo x $b]]
    place $w -x [winfo x $m]\
             -y [expr [winfo y $m]+[winfo y $b]+[winfo height $m]]
    $w.dismiss configure -command "place forget $w; focus [focus]"
    focus $w.line1
}

#-- Over-Plot Marker

set HpkGraphicsOverMarker(1) .
set HpkGraphicsOverMarker(2) .
set HpkGraphicsOverMarker(3) .
set HpkGraphicsOverMarker(4) .
set HpkGraphicsOverMarker(5) .
set HpkGraphicsOverMarker(6) .
set HpkGraphicsOverMarker(7) .
set HpkGraphicsOverMarker(8) .
trace variable HpkGraphicsOverMarker w putGraphicsVar

set w .overMarker
frame $w -relief raised -bd 2
label $w.label -text "OverPlot Markers"
button $w.dismiss -text Dismiss
pack $w.label -side top -anchor w -padx 3 -pady 3
pack $w.dismiss -side bottom -pady 3
set n [array size HpkGraphicsOverMarker]
for {set i 1} {$i <= $n} {incr i} {
    set b $w.marker$i ; set m $b.m
    menubutton $b -text $OrdName($i) -menu $m\
            -relief raised -bd 2 -highlightthickness 2
    pack $b -side left -padx 2
    if {$i !=  1} {bind $b <Left>  "focus $w.marker[expr $i-1]"}
    if {$i != $n} {bind $b <Right> "focus $w.marker[expr $i+1]"}
    bind $b <Enter>  "focus $b"
    bind $b <Down>   "tkMbPost $b; tkMenuFirstEntry $m"
    bind $b <Escape> "$w.dismiss invoke"
    bind $b <KeyPress> "if \[regexp {\[1-$n\]+} \%A\]\
	    {tkMbPost $w.marker\%A ; tkMenuFirstEntry $w.marker\%A.m}"
    menu $m -tearoff 0
    foreach marker {. + O X #} {
        $m add radiobutton -label $marker -underline 0\
		-variable HpkGraphicsOverMarker($i) -value $marker\
                -command "$b configure -text \"$OrdName($i)\n$marker\""
    }
    bind $m <Unmap> "focus $b"
}
bind $w.marker1  <Left>  "focus $w.marker$n"
bind $w.marker$n <Right> "focus $w.marker1"
proc reconfigOverMarker {w b} {
    global HpkGraphicsOverMarker OrdName
    for {set i 1} {$i <= [array size HpkGraphicsOverMarker]} {incr i} {
        set marker [string index $HpkGraphicsOverMarker($i) 0]
	$w.marker$i configure -text "$OrdName($i)\n$marker"
    }
    set m [winfo parent $b]
#   place $w -x [expr [winfo x $m]+[winfo x $b]]
    place $w -x [winfo x $m]\
             -y [expr [winfo y $m]+[winfo y $b]+[winfo height $m]]
    $w.dismiss configure -command "place forget $w; focus [focus]"
    focus $w.marker1
}

#-- 2-Dim Intensity Color

set HpkGraphicsIntColor(1) BLUE
set HpkGraphicsIntColor(2) GREEN
set HpkGraphicsIntColor(3) CYAN
set HpkGraphicsIntColor(4) YELLOW
set HpkGraphicsIntColor(5) MAGENTA
set HpkGraphicsIntColor(6) RED
trace variable HpkGraphicsIntColor w putGraphicsVar

set w .intColor
frame $w -relief raised -bd 2
label $w.label -text "2-Dim. Intensity Colors"
button $w.dismiss -text Dismiss -command "place forget $w"
pack $w.label -side top -anchor w -padx 3 -pady 3
pack $w.dismiss -side bottom -pady 3
set n [array size HpkGraphicsIntColor]
for {set i 1} {$i <=$n} {incr i} {
    set b $w.color$i ; set m $b.m
    menubutton $b -text $OrdName($i) -menu $m\
            -relief raised -bd 2 -highlightthickness 2
    pack $b -side left -padx 2
    if {$i !=  1} {bind $b <Left>  "focus $w.color[expr $i-1]"}
    if {$i != $n} {bind $b <Right> "focus $w.color[expr $i+1]"}
    bind $b <Enter>  "focus $b"
    bind $b <Down>   "tkMbPost $b; tkMenuFirstEntry $m"
    bind $b <Escape> "$w.dismiss invoke"
    bind $b <KeyPress> "if \[regexp {\[1-$n\]+} \%A\]\
	    {tkMbPost $w.color\%A ; tkMenuFirstEntry $w.color\%A.m}"
    menu $m -tearoff 0
    foreach color $ColorList {
        $m add radiobutton -label $color -underline 0\
		-activebackground $color\
		-variable HpkGraphicsOverColor($i)\
                -value [string toupper $color]\
                -command "$b configure -background $color"
    }
    bind $m <Unmap> "focus $b"
}
bind $w.color1  <Left>  "focus $w.color$n"
bind $w.color$n <Right> "focus $w.color1"
proc reconfigIntColor {w b} {
    global HpkGraphicsIntColor
    for {set i 1} {$i <= [array size HpkGraphicsIntColor]} {incr i} {
	$w.color$i configure -background $HpkGraphicsIntColor($i)
    }
    set m [winfo parent $b]
#   place $w -x [expr [winfo x $m]+[winfo x $b]]
    place $w -x [winfo x $m]\
             -y [expr [winfo y $m]+[winfo y $b]+[winfo height $m]]
    focus $w.color1
}

#-- Default Color

set HpkGraphicsDefColor WHITE
trace variable HpkGraphicsDefColor w putGraphicsVar
set m $root.defColor
menu $m -tearoff 0
foreach color $ColorList {
    $m add radiobutton -label $color -underline 0\
	    -activebackground $color\
	    -variable HpkGraphicsDefColor -value [string toupper $color]
}

#-- Font

set HpkGraphicsFont BASIC
trace variable HpkGraphicsFont w putGraphicsVar
set m $root.font
menu $m -tearoff 0
foreach font {Basic Simplex Duplex} {
    $m add radiobutton -label $font -underline 0\
            -variable HpkGraphicsFont -value [string toupper $font]
}

#-- Character Size

set HpkGraphicsCharSize  0.015

set w $root.charSize
menu $w -tearoff 0\
	-postcommand "$w.label configure -text \$HpkGraphicsCharSize"
label $w.label -width 5 -textvariable HpkGraphicsCharSize
scale $w.scale -orient vertical -length 150 -showvalue no\
	-variable HpkGraphicsCharSize\
	-from 0.005 -to 0.045 -resolution 0.001
pack $w.label $w.scale -in $w -padx 2 -pady 2
bind $w <Up>       "tkScaleIncrement $w.scale up   little noRepeat"
bind $w <Down>     "tkScaleIncrement $w.scale down little noRepeat"
bind $w <FocusIn>  "$w.label configure -relief raised"
bind $w <FocusOut> "$w.label configure -relief flat;\
		putGraphicsVar HpkGraphicsCharSize \"\" w"

#-- Window Layout

set HpkGraphicsWin2mode QUADRANT
set HpkGraphicsWinDiv   4X4
trace variable HpkGraphicsWin2mode w putGraphicsVar
trace variable HpkGraphicsWinDiv   w putGraphicsVar
set m $root.window
menu $m -tearoff 0
$m add command -label "Max Division" -state disabled
foreach i {2x2 3x3 4x4} {
    $m add radiobutton -label "upto $i" -underline 5\
            -variable HpkGraphicsWinDiv -value [string toupper $i]
}
$m add separator
$m add command -label "2-Win Mode" -state disabled
foreach i {Quadrant TopBottom LeftRight} {
    $m add radiobutton -label $i -underline 0\
            -variable HpkGraphicsWin2mode -value [string toupper $i]
}

#-- Tic Direction

set HpkGraphicsTicDir INSIDE
trace variable HpkGraphicsTicDir w putGraphicsVar
set m $root.ticDir
menu $m -tearoff 0
foreach i {Inside Outside} {
    $m add radiobutton -label $i -underline 0\
	-variable HpkGraphicsTicDir -value [string toupper $i]
}

#-- Numeric Format

set HpkGraphicsNumFormat DECIMALS
trace variable HpkGraphicsNumFormat w putGraphicsVar
set m $root.numFormat
menu $m -tearoff 0
foreach i {Integers Decimals} {
    $m add radiobutton -label $i -underline 0\
	-variable HpkGraphicsNumFormat -value [string toupper $i]
}

#-- Cursor Bind End

set HpkGraphicsCurBinEnd YES
trace variable HpkGraphicsCurBinEnd w putGraphicsVar
set m $root.curBinEnd
menu $m -tearoff 0
foreach i {Yes No} {
    $m add radiobutton -label $i -underline 0\
	-variable HpkGraphicsCurBinEnd -value [string toupper $i]
}

#-- Auto Scale Bin Width

set HpkGraphicsAutoBinW  0

set w $root.autoBinW
menu $w -tearoff 0\
	-postcommand "$w.label configure -text \$HpkGraphicsAutoBinW"
label $w.label -width 3 -textvariable HpkGraphicsAutoBinW
scale $w.scale -orient vertical -length 100 -showvalue no\
	-variable HpkGraphicsAutoBinW\
	-from 0 -to 10 -resolution 1
pack $w.label $w.scale -in $w -padx 2 -pady 2
bind $w <Up>       "tkScaleIncrement $w.scale up   little noRepeat"
bind $w <Down>     "tkScaleIncrement $w.scale down little noRepeat"
bind $w <FocusIn>  "$w.label configure -relief raised"
bind $w <FocusOut> "$w.label configure -relief flat;\
		putGraphicsVar HpkGraphicsAutoBinW \"\" w"

#-- (Device)

set HpkGraphicsDevice   XWINDOW
trace variable HpkGraphicsDevice  w putGraphicsVar

#-- X-Window

set HpkGraphicsXmode   COLOR
trace variable HpkGraphicsXmode  w putGraphicsVar
set m $root.xwin
menu $m -tearoff 0
$m add command -label "Mode" -state disabled
foreach i {BlackWhite Color} {
    $m add radiobutton -label $i -underline 0\
            -variable HpkGraphicsXmode -value [string toupper $i]
}

#-- PostScript

set HpkGraphicsPSmode    BLACKWHITE
set HpkGraphicsPSorient  LANDSCAPE
set PostScriptRename     0
set PostScriptSpool      1
set PostScriptCount      1
trace variable HpkGraphicsPSmode   w putGraphicsVar
trace variable HpkGraphicsPSorient w putGraphicsVar
set m $root.postscr
menu $m -tearoff 0
$m add command -label "Mode" -state disabled
foreach i {BlackWhite Color} {
    $m add radiobutton -label $i -underline 0\
            -variable HpkGraphicsPSmode -value [string toupper $i]
}
$m add separator
$m add command -label "Orient" -state disabled
foreach i {LandScape Portrait} {
    $m add radiobutton -label $i -underline 0\
            -variable HpkGraphicsPSorient -value [string toupper $i]
}
$m add separator
$m add command -label "File Treat" -state disabled
$m add checkbutton -label Rename     -underline 0 -variable PostScriptRename
$m add checkbutton -label Spool(LPR) -underline 0 -variable PostScriptSpool

#--------------------------------------------------------------

proc reconfigureGraphicsMenu w {
    global HpkGraphicsDefColor
    menuConfig $w {" default color"} activebackground $HpkGraphicsDefColor
}

proc putGraphicsVar {var index action} {
    global HpkSendVar
    if !$HpkSendVar return
    regsub {^HpkGraphics} $var "" key
    if {$index == ""} {
	set command "H Graphics $key $index \$$var"
    } {
	set command "H Graphics $key $index \$$var\($index\)"
    }
    uplevel #0 $command
}

proc saveGraphicsVar {} {
    global HpkGraphicsVarList
    if [file exists [set RC [glob ~]/.pollyrc]] {
	catch "exec mv $RC ${RC}~"
	catch "exec grep -v HpkGraphics ${RC}~ > $RC"
    }
    set fd [open $RC a+]
    foreach var [lsort $HpkGraphicsVarList] {
        if {[set indices [uplevel #0 "array names $var"]] == {}} {
            uplevel #0 "puts $fd \"set $var \$$var\""
        } {
            foreach index [lsort $indices] {
                uplevel #0 "puts $fd \"set ${var}($index) \$${var}($index)\""
            }
        }
    }
    close $fd
}

set HpkSendVar 0 ; # to avoid recursive loop
foreach var [info globals HpkGraphics*] {
    regsub {^HpkGraphics} $var "" name
    if ![array exists $var] {
	set command "H Graphics $name \$$var"
	eval $command
    } {
	foreach i [lsort [array names $var]] {
	    set command "H Graphics $name $i \$$var\($i\)"
	    eval $command
	}
    }
}
set HpkSendVar 1 ; # normal operation

H Graphics Echo ON
