if [catch {
    set HPKfd [open "| [LibDir hpkctrl$ONLINE] $SHMKEY 2> polly.msg" r+]
}] {
    puts "Can't create subprocess \"hpkctrl$ONLINE\"."
    puts "Maybe wrong installation or need -O \[online\] option."
    exit
}
set HPKpid [pid $HPKfd]			; # Process-ID of hpkctrl
bind . <Control-c> "exec kill -INT $HPKpid;\
		    putLog \"# !! Interrupt !!\n\" {tag color2}"
puts $HPKfd "PID [pid]" ; flush $HPKfd	; # put Process-ID of polly
fileevent $HPKfd readable {HPKreply $HPKfd}

set EndDisplay 1
proc H args {
    global HPKfd EndDisplay
    if {!$EndDisplay} {tkwait variable EndDisplay}
    set cmd ""
    foreach i $args {
	if {[string index $i 0] == "'"} {lappend cmd \"$i\"} {lappend cmd $i}
    }
    if {[regexp {^[Dd]} [lindex $args 0]] && ![regexp {\\$} $cmd]} \
            {set EndDisplay 0}
    putLog "H [join $cmd]\n" {}
    puts  $HPKfd [join $args]
    flush $HPKfd
}

proc HPKreply fd {
    global histMask histTarget histList histTitle EndDisplay\
	   HpkGraphicsVarList HpkGraphicsVarName HpkSendVar\
	   PostScriptRename PostScriptCount PostScriptSpool PRINTER\
	   optRangeLower optRangeUpper optResultFile\
	   optXLower optXUpper optXBin optYLower optYUpper optYBin\
	   optSliceDir optSliceLower optSliceUpper optCursorWidget\
	   optPeakStatus optPeakParameter GZX
    if {[gets $fd line] == -1} {
	puts "\n\nSubprocess has died unexpectedly. !!"
	exit
	update
    }
    switch -regexp -- $line {
        {^ *#} {
            putLog "[string trim $line]\n" "tag color2"
            tk_dialog .error Error $line error 0 OK
        }
        {^ *!} {
            putLog "[string trim $line]  -> Notify the author\n" "tag color3"
#            tk_dialog .error Error\
#                    "Internal Error\n$line\nContact with Author" error 0 OK
        }
        {^ *%} {
            regexp {^ *% *(.*)$} $line dummy line
            putLog "# [string trim $line]\n" "tag color2"
            tk_dialog .error Warning $line warning 0 OK
        }
	{^<< FILENAME >>} {
	    gets $fd histTarget
            if {[set EXT [file extension $histTarget]] == ".gz"}\
                    {set EXT [file extension [file rootname $histTarget]]}
            set histMask [file dirname $histTarget]/*$EXT$GZX
	    if {$histTarget == ""} {
		wm title . "Polly <untitled>"
		menuConfig .menu.file.m {reopen save} state disabled
	    } {
		wm title . "Polly \"[file tail $histTarget]\""
		menuConfig .menu.file.m {reopen save} state normal
	    }
	    .hist.listbox activate 0
	}
        {^<< TITLE >>} {
            gets $fd histTitle
	    if {[set len [string length $histTitle]] < 40} {
		.hist.label configure -text "Histogram List \"$histTitle\""
	    } {
		.hist.label configure -text "Histogram List\
			\"[string range $histTitle 0 28]...\
			[string range $histTitle [expr $len-11] end]\""
	    }
        }
        {^<< HLIST >>} {
	    set w .hist.listbox
	    set active [$w index active]
            $w delete 0 end
	    set histList {}
            while {[gets $fd histmem] != -1} {
                if [regexp {^<< EOF >>} $histmem] break
                $w insert end $histmem
		regsub {^ *[0-9]+: *([A-Z0-9!#$&'()+\-\.^_~]+) *[12]D( |\*).*$}\
			$histmem {\1} name
		lappend histList $name
            }
	    $w activate $active
	    $w selection set $active
	    $w see $active
	    if [$w size] {set state normal} {set state disabled}
	    set b .cmdline.buttons
	    $b.display   configure -state $state
	    $b.attribute configure -state $state
	    $b.topdrawer configure -state $state
	    $b.reset     configure -state $state
	    menuConfig .menu.file.m {"save as ..."} state $state
	    menuConfig .menu.file.m {print} state disabled
        }
        {^<< ENDDISP >>} {
            if {[gets $fd line] == -1} break
            scan $line "%s %d" ugdevice gcursor
            if {$ugdevice == "XWINDOW"} {
                if $gcursor {
                    .cmdline.buttons.gcursor configure -state normal
                }
            } {
                if $PostScriptSpool {
                    if {$PRINTER == ""} {
                        printerQueue
                        tkwait window .printerQueue
                    }
                    eval "exec lpr -P$PRINTER $ugdevice"
                    putLog "# $ugdevice spooled -> $PRINTER\n" {tag color1}
                }
                if $PostScriptRename {
                    while {[file exists polly.ps.$PostScriptCount]}\
                            {incr PostScriptCount}
                    exec mv $ugdevice polly.ps.$PostScriptCount
                    putLog "# $ugdevice renamed ->\
                            polly.ps.$PostScriptCount\n" {tag color1}
                }
	    }
	    set EndDisplay 1
        }
	{^<< GRAPHICS >>} {
	    if ![info exists HpkGraphicsVarList] {
		uplevel #0 {set HpkGraphicsVarList [info globals HpkGraphics*]}
		foreach var $HpkGraphicsVarList {
		    regsub HpkGraphics $var "" name
		    lappend HpkGraphicsVarName [string toupper $name]
		}
	    }
	    while {[gets $fd line] != -1} {
		if [regexp {^<< EOF >>} $line] break
                regsub { +} $line " " line
		set cmd [split $line " "]
		set i [lsearch $HpkGraphicsVarName [lindex $cmd 0]]
		if {$i != -1} {
		    set HpkSendVar 0
		    set name [lindex $HpkGraphicsVarList $i]
		    if {[llength $cmd] == 2} {
			uplevel #0 "set $name [lindex $cmd 1]"
		    } {
			uplevel #0\
                                "set $name\([lindex $cmd 1]\) [lindex $cmd 2]"
		    }
		    set HpkSendVar 1
		}
	    }
	}
        {^<< CEND >>} {
            grab release .spacer1
	    . configure -cursor {}
        }
        {^<< ATTRIB >>} {
            attribute $fd
        }
	{^<< ONLINE >>} {
	    menuConfig .menu.file.m   {
                "open ..." reopen new "include ..." "cumulate ..."
            } state disabled
	    menuConfig .menu.file.m   {"save as ..."}    state normal
	    menuConfig .menu.edit.m   {cut paste rename} state disabled
	    menuConfig .menu.option.m {manipulate user}  state disabled
	}
	{^<< MAN_INFO >>} {
            if {[gets $fd line] != -1} {scan $line " %d" ndim}
            if {[gets $fd line] != -1}\
		    {scan $line " %f %f %d" optXLower optXUpper optXBin}
	    if {$ndim != 2} {
		set optYLower 0; set optYUpper 1; set optYBin 0
	    } {
		if {[gets $fd line] != -1}\
			{scan $line " %f %f %d" optYLower optYUpper optYBin}
		if {[gets $fd line] != -1}\
			{scan $line " %d %f %f"\
				optSliceDir optSliceLower optSliceUpper}
	    }
	}
	{^<< FIT_INFO >>} {
            if {[gets $fd line] != -1} {
		scan $line " %d %f %f %f %f"\
			ndim optRangeLower optRangeUpper dummy1 dummy2
                for {set i 7} {$i > 0} {incr i -2}\
                        {$optCursorWidget.pair$i configure -state disabled}
		if {$ndim != 1} {
		    tk_dialog .error "Not 1-DIM"\
			    "Histogram is not 1-dimensional" error 0 OK
		} {
                    while {[gets $fd line] != -1} {
                        if [regexp {^<< EOF >>} $line] break
                        scan $line " %d %f %f" i lower upper
                        $optCursorWidget.pair$i configure -command "\
                                set optRangeLower $lower ;\
                                set optRangeUpper $upper" -state normal
                    }
                }
            }
	}
	{^<< PEAK_INFO >>} {
	    for {set i 1} {$i < 9} {incr i} {set optPeakStatus($i) 0}
	    while {[gets $fd line] != -1} {
		if [regexp {^<< EOF >>} $line] break
		scan $line " %d %f %f" i cursor value
		set optPeakStatus($i) 1
		set optPeakParameter($i,amplitude) $value
		set optPeakParameter($i,centroid)  $cursor
	    }
	}
	{^<< PEAK_RESULT >>} {
	    while {[gets $fd line] != -1} {
		if [regexp {^<< EOF >>} $line] break
                uplevel #0 $line
	    }
	}
        {^<< RESULT >>} {
	    if {$optResultFile == ""} {
		set fw stdout
	    } {
		if [file exists $optResultFile]\
			{exec mv $optResultFile $optResultFile~}
		if [catch {set fw [open $optResultFile w]}] {
		    putLog "# Open Error ($optResultFile)." "tag color2"
		    set fw stdout
		}
	    }
            if {$fw == "stdout"} {puts \n$line}
            while {[gets $fd line] != -1} {
                if [regexp {^<< EOF >>} $line] break
                putLog "$line\n" "tag color1"
                puts $fw $line
            }
	    if {$fw != "stdout"} {close $fw}
	    set optResultFile ""
        }
        default {
            putLog "# $line\n" "tag color1"
#           puts $line
        }
    }
}

proc readHPK target {
    if [file exists $target] {
	H File Open $target
    } else {
	tk_dialog .error "No File" \
		"File does NOT Exist.\n\"$target\"" error 0 OK
    }
}

#-------------------------------------------------

if [info exist env(PRINTER)] {set PRINTER $env(PRINTER)} {set PRINTER ""}

proc printerQueue {} {
    global LPSTATUS PRINTER PostScriptSpool PostScriptRename

    set w .printerQueue
    set b $w.buttons

    if ![winfo exists $w] {
	toplevel $w
	wm title    $w "Polly/PrinterQueue"
	wm iconname $w "Polly/PrinterQueue"

	label $w.label -text "Current Queue:"
	listbox $w.listbox -setgrid 1 -yscrollcommand "$w.scrollbar set"
	scrollbar $w.scrollbar -command "$w.listbox yview"
	checkbutton $w.spool  -text "Spool(LPR)" -underline 0\
		-variable PostScriptSpool
	checkbutton $w.rename -text "Rename & Save" -underline 0\
		-variable PostScriptRename
	frame $w.buttons
	pack $w.label -side top -anchor w -pady 1m
	pack $w.buttons -side bottom -pady 2m
	pack $w.rename -side bottom -anchor w
	pack $w.spool  -side bottom -anchor w
	pack $w.scrollbar -side right -fill y
	pack $w.listbox -fill both -expand 1 -padx 1m
	bind $w.listbox <Double-1> "$b.ok invoke"

	button $b.ok     -text "OK"
	button $b.cancel -text "Cancel"
	pack $b.ok $b.cancel -side left -padx 2m
	bind $w <Return> "$b.ok     invoke"
	bind $w <Escape> "$b.cancel invoke"
	bind $w <Alt-s>  "$w.spool  invoke"
	bind $w <Alt-r>  "$w.rename invoke"

	if ![catch {set fd [open "| $LPSTATUS " r]}] {
	    while {[gets $fd line] != -1} {
		switch -regexp -- $line {
		    {^.+:} {
			regsub { *(.+):} $line {\1} name
			$w.listbox insert end $name
		    }
		    {queuing} {
			if {[string first enabled $line] == -1}\
				{ $w.listbox delete end}
		    }
		}
	    }
	    close $fd
	}

	wm withdraw $w
	update idletasks
	set x [expr [winfo screenwidth  $w]/2 - [winfo reqwidth  $w]/2 \
		- [winfo vrootx [winfo parent $w]]]
	set y [expr [winfo screenheight $w]/2 - [winfo reqheight $w]/2 \
		- [winfo vrooty [winfo parent $w]]]
	wm geom $w +$x+$y
    }

    $w.label configure -text "Current Queue: $PRINTER"
    for {set i 0} {$i < [$w.listbox size]} {incr i} {
	if {[$w.listbox get $i] == "$PRINTER"} {
	    $w.listbox activate $i
	    $w.listbox selection set active
	}
    }
    $b.ok configure -command "\
	    set PRINTER \[$w.listbox get active\];\
	    focus [focus]; wm withdraw $w"
    $b.cancel configure -command "\
	    focus [focus]; wm withdraw $w"
    wm deiconify $w
    focus $w.listbox
}
