#-- Extra Key-Binding ------------------------------

bind Entry   <Delete>      [bind Entry <BackSpace>]
bind Entry   <Control-u>   {%W delete 0 end}

bind Listbox <Control-p>   [bind Listbox <Up>   ]
bind Listbox <Control-n>   [bind Listbox <Down> ]
bind Listbox <Control-b>   [bind Listbox <Left> ]
bind Listbox <Control-f>   [bind Listbox <Right>]
bind Listbox <Alt-less>    {
    %W activate 0
    %W see 0
    %W selection clear 0 end
    %W selection set 0
}
bind Listbox <Alt-greater> {
    %W activate end
    %W see end
    %W selection clear 0 end
    %W selection set end
}
bind Listbox <Control-v>   {
    %W yview scroll 1 pages
    %W activate @0,0
    %W selection set active
}
bind Listbox <Alt-v>       {
    %W yview scroll -1 pages
    %W activate @0,0
    %W selection set active
}

bind Text    <Delete>      {
    if {[%W tag nextrange sel 1.0 end] != ""} {
	%W delete sel.first sel.last
    } elseif [%W compare insert != 1.0] {
	%W delete insert-1c
	%W see insert
    }
}
bind Text    <Alt-less>    [bind Text <Control-Home>]
bind Text    <Alt-greater> [bind Text <Control-End> ]
bind Text    <Control-v>   [bind Text <Next>        ]
bind Text    <Alt-v>       [bind Text <Prior>       ]
bind Text <Alt-w> {
    set tkPriv(selectMode) char
    if {[selection own -displayof %W] == "%W"} {
	if {[%W tag ranges sel] == ""} {tkTextKeyExtend %W insert}
    } {
	tkTextKeyExtend %W insert
    }
    clipboard clear -displayof %W
    catch {
	clipboard append -displayof %W [selection get -displayof %W]
    }
}
bind Text <Control-w> {
    set tkPriv(selectMode) char
    if {[selection own -displayof %W] == "%W"} {
	if {[%W tag ranges sel] == ""} {tkTextKeyExtend %W insert}
    } {
	tkTextKeyExtend %W insert
    }
    clipboard clear -displayof %W
    catch {
	clipboard append -displayof %W [selection get -displayof %W]
	%W delete sel.first sel.last
    }
}
bind Text <Control-y> {
    catch {
	%W insert insert [selection get -displayof %W \
		-selection CLIPBOARD]
    }
}

bind Menu <Control-b> [bind Menu <Left> ]
bind Menu <Control-f> [bind Menu <Right>]
bind Menu <Control-p> [bind Menu <Up>   ]
bind Menu <Control-n> [bind Menu <Down> ]

bind Scale <Control-p> [bind Scale <Up>   ]
bind Scale <Control-n> [bind Scale <Down> ]
bind Scale <Control-b> [bind Scale <Left> ]
bind Scale <Control-f> [bind Scale <Right>]
bind Scale <Shift-Up>    [bind Scale <Control-Up>  ]
bind Scale <Shift-Down>  [bind Scale <Control-Down>]
bind Scale <Shift-Left>  [bind Scale <Control-Left>]
bind Scale <Shift-Right> [bind Scale <Control-Right>]

#-- Create Images ---------------------------------------

foreach i {Solid Broken Dotted Chain Left Right Up Down Polly} {
    image create bitmap image[string toupper $i]\
	    -file [LibDir bitmap]/[string tolower $i].bmp
}

#-- Default X-resources  --------------------------------

# XLFD fonts to force the same look&feel as older tk4.x even for jp-version.
option add *Button.font  -*-Helvetica-Bold-R-Normal--*-120-* startupFile
option add *Menu.font    -*-Helvetica-Bold-R-Normal--*-120-* startupFile
option add *Scale.font   -*-Helvetica-Bold-R-Normal--*-120-* startupFile
option add *Entry.font   -*-Courier-Medium-R-Normal--*-120-* startupFile
option add *Listbox.font -*-Courier-Medium-R-Normal--*-120-* startupFile
option add *Text.font    -*-Courier-Medium-R-Normal--*-120-* startupFile

option readfile [LibDir Polly.ad] startupFile

#-- Global Constants ------------------------------------

set TextSearchTagForeground white
set TextSearchTagBackground red

#-- System Dependence -----------------------------------

switch [exec uname] {
    Linux {set LPSTATUS "/usr/sbin/lpc status"}
    SunOS {set LPSTATUS "lpc status"}
    OSF1  {set LPSTATUS "lpstat -a" }
}

#-- Trap for Tk8.0 or later -----------------------------

if {$tk_version >= 8.0} {

# stop NASTY behavior of "cascade" menu

proc tkMenuNextEntry {menu count} {
    global tkPriv

    if {[$menu index last] == "none"} {
	return
    }
    set length [expr {[$menu index last]+1}]
    set quitAfter $length
    set active [$menu index active]
    if {$active == "none"} {
	set i 0
    } else {
	set i [expr {$active + $count}]
    }
    while 1 {
	if {$quitAfter <= 0} {
	    # We've tried every entry in the menu.  Either there are
	    # none, or they're all disabled.  Just give up.

	    return
	}
	while {$i < 0} {
	    incr i $length
	}
	while {$i >= $length} {
	    incr i -$length
	}
	if {[catch {$menu entrycget $i -state} state] == 0} {
	    if {$state != "disabled"} {
		break
	    }
	}
	if {$i == $active} {
	    return
	}
	incr i $count
	incr quitAfter -1
    }
    $menu activate $i
    tkGenerateMenuSelect $menu
    if {[$menu type $i] == "cascade"} {
	set cascade [$menu entrycget $i -menu]
	if {[string compare $cascade ""] != 0} {
	    $menu postcascade $i
	    #tkMenuFirstEntry $cascade
	}
    }
}

proc tkMenuFirstEntry menu {
    if {$menu == ""} {
	return
    }
    tk_menuSetFocus $menu
    if {[$menu index active] != "none"} {
	return
    }
    set last [$menu index last]
    if {$last == "none"} {
	return
    }
    for {set i 0} {$i <= $last} {incr i} {
	if {([catch {set state [$menu entrycget $i -state]}] == 0)
		&& ($state != "disabled") && ([$menu type $i] != "tearoff")} {
	    $menu activate $i
	    tkGenerateMenuSelect $menu
	    if {[$menu type $i] == "cascade"} {
		set cascade [$menu entrycget $i -menu]
		if {[string compare $cascade ""] != 0} {
		    #$menu postcascade $i
		    #tkMenuFirstEntry $cascade
		}
	    }
	    return
	}
    }
}

}
