set root .menu.option.m

set m $root.manipulate
menu $m ;#-postcommand "checkManipulate $m"
$m add command -label "Arithmetic..." -underline 0 -command optArithmetic
source [LibDir arithmetic.tcl]
$m add command -label "Binning" -underline 0 -command {
    genOption .optManBin Binning 3 0 {
	global optBinWidX optBinOfsX optBinWidY optBinOfsY
	foreach i {X Y} {
	    set optBinWid$i 2
	    set optBinOfs$i 0
	    set pw $p.[string tolower $i]
	    frame $pw
	    pack  $pw -side top -fill x -expand 1
	    label $pw.label -text "$i-Bin:" -underline 0
	    scale $pw.width  -label Width  -orient horizontal -showvalue yes\
		    -from 2 -to 20 -variable optBinWid$i
	    scale $pw.offset -label Offset -orient horizontal -showvalue yes\
		    -from 0 -to 19 -variable optBinOfs$i
	    pack $pw.label -side top -anchor w
	    pack $pw.width $pw.offset -side left -expand 1
	    bind $w <Alt-[string tolower $i]><Any-w> "focus $pw.width"
	    bind $w <Alt-[string tolower $i]><Any-o> "focus $pw.offset"
	    bind $pw.offset <FocusIn>\
		    "$pw.offset configure -to \[expr \$optBinWid$i-1\]"
	}
    } {
        H Option Manipulate Binning $optSource $optDestin\
		$optBinWidX $optBinOfsX $optBinWidY $optBinOfsY [OptComments]
    }
}
$m add command -label "sHift"   -underline 1 -command {
    genOption .optManShift Shift 3 0 {
	global optShiftX optShiftY
	foreach i {X Y} {
	    set optShift$i 0
	    set pw $p.[string tolower $i]
	    frame $pw
	    pack  $pw -side top ;# -fill x -expand 1
	    label $pw.label -text "$i-Shift:\t" -underline 0
	    entry $pw.entry -textvariable optShift$i -width 20
	    pack  $pw.label $pw.entry -side left -anchor w
	    bind  $w <Alt-[string tolower $i]> "focus $pw.entry"
	}
    } {
	if [CheckNumInput\
		$optShiftX "X Shift" .optManShift.param.x.entry] {
	    if [CheckNumInput\
		    $optShiftY "Y Shift" .optManShift.param.y,entry] {
		H Option Manipulate Shift $optSource $optDestin\
			$optShiftX $optShiftY [OptComments]
	    }
	}
    }
}
$m add command -label "Offset"  -underline 0 -command {
    genOption .optManOffset Offset 3 0 {
	global optOffset
	set optOffset 0
	label $p.label -text Offset:\t -underline 0
	entry $p.entry -textvariable optOffset -width 10
	pack  $p.label $p.entry -side left -anchor w
	bind $w <Alt-o> "focus $p.entry"
    } {
	if [CheckNumInput $optOffset "Offset" .optManOffset.param.entry] {
	    H Option Manipulate Offset\
		    $optSource $optDestin $optOffset [OptComments]
	}
    }
}
$m add separator
$m add command -label "Slice 2D->1D" -underline 0 -command {
    genOption .optManSlice Slice -2 0 {
	global optSliceDir optSliceLower optSliceUpper
        set pd $p.direction
        frame $pd
        pack  $pd -side top
	set j 0
	foreach i {X Y} {
	    radiobutton $pd.onto$i -text "onto_$i" -underline 5\
		    -variable optSliceDir -value $j
	    bind $w <Alt-[string tolower $i]> "$pd.onto$i invoke"
	    incr j
	}
	pack $pd.ontoX $pd.ontoY -side left
        label $p.llabel -text Lower: -underline 0
        entry $p.lentry -textvariable optSliceLower -width 10
        label $p.ulabel -text Upper: -underline 0
        entry $p.uentry -textvariable optSliceUpper -width 10
        pack  $p.llabel $p.lentry $p.ulabel $p.uentry -side left
        bind $w <Alt-l> "focus $p.lentry"
        bind $w <Alt-u> "focus $p.uentry"
    } {
        if [CheckNumInput $optSliceLower "Lower"\
                .optManSlice.param.lentry] {
            if [CheckNumInput $optSliceUpper "Upper"\
                    .optManSlice.param.uentry] {
                H Option Manipulate Slice $optSource $optDestin\
                        $optSliceDir $optSliceLower $optSliceUpper
            }
        }
    }
}
$m add command -label "Mean 2D->1D" -underline 0 -command {
    genOption .optManMean2D Mean2D -2 0 {
	global optDirection
	set optDirection 0
	set j 0
	foreach i {X Y} {
	    radiobutton $p.onto$i -text "onto_$i" -underline 5\
		    -variable optDirection -value $j
	    bind $w <Alt-[string tolower $i]> "$p.onto$i invoke"
	    incr j
	}
	pack $p.ontoX $p.ontoY -side left
    } {
	H Option Manipulate Mean2D $optSource $optDestin $optDirection
    }
}
$m add command -label "Gate 2D->1D" -underline 0 -command {
    genOption .optManGate Gate -2 0 {
	global optDirection optCursorPair
	set optDirection 0
	set optCursorPair 1
	label $p.label -text "Cursor Pair:"
	pack  $p.label -side top -anchor w
	set pc $p.cursor
	frame $pc
	pack  $pc -side top -fill x -expand 1
	for {set j 7} {$j >= 0} {incr j -2} {
	    radiobutton $pc.pair$j -text "$j-[expr $j+1]" -underline 0\
		    -variable optCursorPair -value $j
	    pack $pc.pair$j -side right
	    bind $w <Alt-KeyPress-$j> "$pc.pair$j invoke"
	}
	set pd $p.direction
	frame $pd
	pack  $pd -side bottom -fill x -expand 1
	label $pd.label -text Direction:
	pack  $pd.label -side left -anchor w
	set j -1
	foreach i {X Y} {
	    radiobutton $pd.onto$i -text "onto_$i" -underline 5\
		    -variable optDirection -value [incr j]
	    pack $pd.onto$i -side left
	    bind $w <Alt-[string tolower $i]> "$pd.onto$i invoke"
	}
    } {
	H Option Manipulate Gate $optSource $optDestin\
		$optCursorPair $optDirection
    }
}
$m add command -label "sWap Axes" -underline 1 -command {
    genOption .optManSwap SwapAxes -2 0 {} {
	H Option Manipulate SwapAxes $optSource $optDestin
    }
}

#--------------------------------------------------------------

set m $root.fit
menu $m
$m add command -label Polynomial  -underline 0 -command {
    genOption .optFitPoly PolynomialFit 0 1 {
	global optPolyOrder
	set optPolyOrder 1
	label $p.label -text Order: -underline 0
	scale $p.scale -orient horizontal -showvalue yes\
		-from 0 -to 10 -variable optPolyOrder
	pack $p.label $p.scale -side left -anchor w
	bind $w <Alt-o> "focus $p.scale"
    } {
	H Option Fit Polynomial $optSource\
		$optRangeLower $optRangeUpper $optPolyOrder $optResidue
    }
}
$m add command -label Gaussian    -underline 0 -command {
    genOption .optFitGauss GaussianFit 0 1 {
	global optSetCursor
	checkbutton $p.cursor -text "Set Cursor" -underline 4\
		-variable optSetCursor
	pack $p.cursor -anchor w
	bind $w <Alt-c> "$p.cursor invoke"
    } {
	H Option Fit Gaussian $optSource\
		$optRangeLower $optRangeUpper $optSetCursor $optResidue
    }
}
$m add command -label Lorentzian  -underline 0 -command {
    genOption .optFitLorentz LorentzianFit 0 1 {
	global optSetCursor
	checkbutton $p.cursor -text "Set Cursor" -underline 4\
		-variable optSetCursor
	pack $p.cursor -anchor w
	bind $w <Alt-c> "$p.cursor invoke"
    } {
	H Option Fit Lorentzian $optSource\
		$optRangeLower $optRangeUpper $optSetCursor $optResidue
    }
}
$m add command -label eXponential -underline 1 -command {
    genOption .optFitExponent ExponentialFit 0 1 {
	global optExponent optConstBack
	set optExponent 1
	label $p.label -text eXponential_No.: -underline 1
	scale $p.scale -orient horizontal -showvalue yes\
		-from 1 -to 5 -variable optExponent
	checkbutton $p.constBack -text "constant BackGround" -underline 9\
		-variable optConstBack
        pack $p.constBack -side bottom -anchor w
	pack $p.label $p.scale -side left -anchor w
	bind $w <Alt-x> "focus $p.scale"
        bind $w <Alt-b> "$p.constBack invoke"
    } {
	H Option Fit Exponential $optSource\
	  $optRangeLower $optRangeUpper $optExponent $optConstBack $optResidue
    }
}
$m add command -label HistComb    -underline 0 -command {
    genOption .optFitHist HistogramFit 0 1 {
	global optHistList optConstBack optAllowShift histList
	label $p.label -text "Histograms:" -underline 0
	pack  $p.label -side top -anchor w
	checkbutton $p.constBack -text "constant BackGround" -underline 9\
		-variable optConstBack
        pack $p.constBack -side bottom -anchor w
	bind $w <Alt-b> "$p.constBack invoke"
	checkbutton $p.allowShift -text "Allow Shift" -underline 0\
		-variable optAllowShift
        pack $p.allowShift -side bottom -anchor w
	bind $w <Alt-a> "$p.allowShift invoke"
	frame $p.spacer -width 2m
        pack $p.spacer -side left -expand 1
	listbox $p.listbox -width 18 -height 10
	pack $p.listbox -side left
	bind $w <Alt-h> "focus $p.listbox; $p.listbox selection set active"
	button $p.pickup -text PickHist -underline 0 -width 8 -command\
	   "set name \[lindex \$histList \[.hist.listbox index active\]\];\
	    if {\[lsearch -exact \$optHistList \$name\] == -1} {\
		$p.listbox insert end \$name};\
	    lappend optHistList \$name;\
	    tkListboxUpDown .hist.listbox 1"
	button $p.delete -text Delete -underline 0 -width 8 -command\
		"set i \[$p.listbox index active\];\
		 $p.listbox delete active;\
		 set optHistList \[lreplace \$optHistList \$i \$i\]"
	button $p.clear -text ClearAll -underline 0 -width 8 -command\
		"$p.listbox delete 0 end; set optHistList {}"
	pack $p.pickup $p.delete $p.clear -side top ;#-anchor w
	bind $w <Alt-p> "$p.pickup invoke"
	bind $w <Alt-d> "$p.delete invoke"
	bind $w <Alt-c> "$p.clear  invoke"
	set  q $p.listbox
	set  l .hist.listbox
	bind $q <KP_Enter>  "$p.pickup invoke"
	bind $q <Up>        "tkListboxUpDown $l -1"
	bind $q <Down>      "tkListboxUpDown $l  1"
	bind $q <Control-p> "tkListboxUpDown $l -1"
	bind $q <Control-n> "tkListboxUpDown $l  1"
	bind $q <Shift-Up>  "tkListboxExtendUpDown $l -1"
	bind $q <Shift-Down> "tkListboxExtendUpDown $l  1"
	bind $q <Alt-less>  {histListboxSelect "0" ""}
	bind $q <Alt-greater> {histListboxSelect "end" ""}
	bind $q <Prior>     {histListboxSelect "@0,0" "yview scroll -1 pages"}
	bind $q <Next>      {histListboxSelect "@0,0" "yview scroll  1 pages"}
	bind $q <Alt-v>     {histListboxSelect "@0,0" "yview scroll -1 pages"}
	bind $q <Control-v> {histListboxSelect "@0,0" "yview scroll  1 pages"}
	set optHistList {}
    } {
	set n [.optFitHist.param.listbox size]
	if {$n == 0} {
	    tk_dialog .error "Empty List"\
		    "Empty Histogram List" error 0 OK
	} {
	    if {$n > 10} {
		tk_dialog .error "Too Many Hist"\
			"Too Many Histograms" error 0 OK
	    } {
		set optHistList ""
		for {set i 0} {$i < $n} {incr i} {
		    set optHistList\
			    "$optHistList [.optFitHist.param.listbox get $i]"
		}
		H Option Fit Histogram $optSource\
			$optRangeLower $optRangeUpper ([join $optHistList])\
			$optConstBack $optAllowShift $optResidue
	    }
	}
    }
}
$m add command -label UserFunc    -underline 0 -state disabled

#--------------------------------------------------------------

set m $root.peak
menu $m
$m add command -label Search -underline 0 -command {
    genOption .optPeakSearch PeakSearch 0 1 {
	global optPeakWidth optPeakThres optSetCursor
	set optPeakWidth 1
	set optPeakThres 3
	set pw $p.width
	frame $pw
	label $pw.label -text Width:\t -underline 0
	entry $pw.entry -textvariable optPeakWidth -width 10
	pack $pw.label $pw.entry -side left
	bind $w <Alt-w> "focus $pw.entry"
	set pt $p.thres
	frame $pt
	label $pt.label -text Threshld:\t -underline 0
	entry $pt.entry -textvariable optPeakThres -width 10
	pack $pt.label $pt.entry -side left
	bind $w <Alt-t> "focus $pt.entry"
	checkbutton $p.cursor -text "Set Cursor" -underline 4\
		-variable optSetCursor
	bind $w <Alt-c> "$p.cursor invoke"
	pack $pw $pt $p.cursor -side top -anchor w
	pack forget .optPeakSearch.fit.residue ; # !! tricky !!
    } {
	if [CheckNumInput $optPeakWidth\
		"Peak Width" .optPeakSearch.param.width.entry] {
	    if [CheckNumInput $optPeakThres\
		    "Peak Threshold" .optPeakSearch.param.thres.entry] {
		H Option Peak Search $optSource $optRangeLower $optRangeUpper\
			$optPeakWidth $optPeakThres $optSetCursor
	    }
	}
    }
}
$m add command -label Fit    -underline 0 -command {
    genOption .optPeakFit PeakFit 0 2 {
	global optPeakMaxRepeat optPeakConvergence
	set optPeakMaxRepeat   500
	set optPeakConvergence 1.E-5
	button $p.param -text Parameters -underline 0 -pady 0\
		-command "focus .optPeakParam"
	pack  $p.param -side bottom -padx 2m -pady 2 -fill x -expand 1
	bind  $w <Alt-p> "$p.param invoke"
        frame $p.maxrepeat
        label $p.maxrepeat.label -text MaxRepeat: -underline 0
        entry $p.maxrepeat.entry -textvariable optPeakMaxRepeat -width 6
        pack  $p.maxrepeat.label $p.maxrepeat.entry -side left
        bind  $w <Alt-m> "focus $p.maxrepeat.entry"
        frame $p.convergence
        label $p.convergence.label -text Convergence: -underline 0
        entry $p.convergence.entry -textvariable optPeakConvergence -width 6
        pack  $p.convergence.label $p.convergence.entry -side left
        bind  $w <Alt-c> "focus $p.convergence.entry"
        pack  $p.maxrepeat $p.convergence -side left -fill x -expand 1
    } {
	if ![CheckNumInput $optPeakMaxRepeat\
		"MaxRepeat" .optPeakFit.param.maxrepeat.entry] return
	if ![CheckNumInput $optPeakConvergence\
		"Convergence" .optPeakFit.param.convergence.entry] return
	if ![optPeakParamOut] return
	H Option Peak Condition $optPeakMaxRepeat $optPeakConvergence
	H Option Peak Fit $optSource\
		$optRangeLower $optRangeUpper $optSetCursor $optResidue
    }
}

proc optPeakParam {} {
    global optPeakStatus optPeakHistogram optSource histList

    set w .optPeakParam
    if ![winfo exists $w] {
	toplevel $w
	wm title    $w "Polly/Option(PeakFitParam)"
	wm iconname $w "Polly/Option(PeakFitParam)"

	set p $w.peak
	frame $p -relief groove -bd 2
	pack  $p -padx 2 -pady 2 -fill x -expand 1
	set v $p.label
	frame $v
	pack  $v -side top -fill x -expand 1
	label $v.label -text "Peak parameters"
	pack  $v.label -side top -anchor w
	label $v.n -text "  No."
	pack  $v.n -side left -anchor w
	set relx [expr 2./9.]
	foreach i {Amplitude Centroid Width@1/2 Ratio(R/L)} {
	    regexp {^[a-z]+} [string tolower $i] widget
	    set u $v.$widget
	    label $u -text $i -underline 0
	    place $u -anchor c -relx $relx -rely 0.72
	    set relx [expr $relx+2./9.]
	}
	for {set i 1} {$i < 9} {incr i} {
	    set v $p.param$i
	    frame $v
	    pack  $v -side top -fill x -expand 1
	    checkbutton $v.state -text "$i:  " -underline 0\
		    -variable optPeakStatus($i)
	    pack  $v.state -side left -anchor w
	    bind  $w <Alt-KeyPress-$i> "focus $v.state"
	    if {$i != 1} {
		bind  $v.state <Up>        "focus $p.param[expr $i-1].state"
		bind  $v.state <Control-p> "focus $p.param[expr $i-1].state"
	    }
	    if {$i != 8} {
		bind  $v.state <Down>      "focus $p.param[expr $i+1].state"
		bind  $v.state <Control-n> "focus $p.param[expr $i+1].state"
	    }
	    foreach j {amplitude centroid width ratio} {
		set m $v.${j}Menu.m
		menubutton $v.${j}Menu -menu $m\
			-padx 0 -pady 0 -relief raised -width 2
		entry $v.${j}Entry -width 10\
			-textvariable optPeakParameter($i,$j)
		pack  $v.${j}Menu $v.${j}Entry -side left
		bind  $v.state <KeyPress-[string index $j 0]>\
			"focus $v.${j}Entry"
		bind  $v.${j}Entry <Alt-Down> "tkMbPost $v.${j}Menu"
		if {$i != 1} {
		    bind $v.${j}Entry <Up>\
			    "focus $p.param[expr $i-1].${j}Entry"
		    bind $v.${j}Entry <Control-p>\
			    "focus $p.param[expr $i-1].${j}Entry"
		}
		if {$i != 8} {
		    bind $v.${j}Entry <Down>\
			    "focus $p.param[expr $i+1].${j}Entry"
		    bind $v.${j}Entry <Control-n>\
			    "focus $p.param[expr $i+1].${j}Entry"
		}
		bind  $v.${j}Entry <Alt-s> "$v.${j}Menu configure -text S"
		bind  $v.${j}Entry <Alt-f> "$v.${j}Menu configure -text F"
		bind  $v.${j}Entry <Alt-c> "tkMbPost $v.${j}Menu;\
			$v.${j}Menu.m invoke end;\
			$v.${j}Menu.m.common activate 0"
		menu  $m -tearoff 0
		$m add command -label Search -underline 0 -command\
			"$v.${j}Menu configure -text S"
		$m add command -label Fix    -underline 0 -command\
			"$v.${j}Menu configure -text F"
		$m add cascade -label Common -underline 0 -menu $m.common
		menu  $m.common -tearoff 0
		for {set k 1} {$k < 9} {incr k} {
		    if {$k != $i} {
			$m.common add command -label $k -underline 0 -command\
				"$v.${j}Menu configure -text C;\
                                 $v.${j}Entry delete 0 end;\
                                 $v.${j}Entry insert end $k"
		    }
		}
	    }
	}
	set v $p.buttons
	frame $v
	pack  $v -side top -anchor e
	button $v.cursor -text "Get from Cursor" -underline 0 -padx 0 -pady 0\
		-command {H Option Peak Cursor_Info $optSource}
	button $v.reset  -text Reset -padx 0 -pady 0\
		-command optPeakParamReset
	pack  $v.cursor $v.reset -side left -padx 1m
	bind  $w <Alt-g> "$v.cursor invoke"
	trace variable optPeakStatus w optPeakStatusSet
	proc optPeakStatusSet {var index action} {
	    global optPeakStatus
	    set v .optPeakParam.peak.param$index
	    if $optPeakStatus($index) {
		foreach j {amplitude centroid width ratio} {
		    $v.${j}Menu  configure -state normal
		    $v.${j}Entry configure -state normal
		}
	    } {
		foreach j {amplitude centroid width ratio} {
		    $v.${j}Menu  configure -state disabled
		    $v.${j}Entry configure -state disabled
		}
	    }
	}
	proc optPeakParamReset {} {
	    global optPeakStatus optPeakParameter
	    set w .optPeakParam
	    array set SFCvalue {amplitude S   centroid S width C ratio F}
	    array set ENTvalue {amplitude 100 centroid 0 width 1 ratio 1}
	    for {set i 1} {$i < 9} {incr i} {
		set optPeakStatus($i) 0
		foreach j {amplitude centroid width ratio} {
		    $w.peak.param$i.${j}Menu configure -text $SFCvalue($j)
		    set optPeakParameter($i,$j) $ENTvalue($j)
		}
	    }
	    $w.peak.param1.widthMenu configure -text S
	    set optPeakStatus(1) 1
	}
	optPeakParamReset

	set b $w.background
	frame $b -relief groove -bd 2
	pack  $b -padx 2 -pady 2 -fill x -expand 1
	label $b.label -text Backgrounds
	pack  $b.label -side top -anchor w

	set l $b.polynomial
	frame $l
	pack  $l -side top -pady 2 -fill x -expand 1
        button $l.reset -text Reset -padx 0 -pady 0\
		-command optPeakPolynomialReset
	pack  $l.reset -side top -anchor e
	label $l.label -text " Polynomial: (n-th coefficient)" -underline 1
	place $l.label -anchor nw -x 0 -y 0
	label $l.space -text "   "
	pack  $l.space -side left
	for {set i 0} {$i < 4} {incr i} {
	    label $l.label$i -text " $i:"
	    set m $l.menu$i.m
	    menubutton $l.menu$i -menu $m\
		    -padx 0 -pady 0 -relief raised -width 2
	    entry $l.entry$i -width 8 -textvariable optPeakPolynomial($i)
	    menu  $m -tearoff 0
	    $m add command -label Search -underline 0 -command\
		    "$l.menu$i configure -text S"
	    $m add command -label Fix    -underline 0 -command\
		    "$l.menu$i configure -text F"
	    pack  $l.label$i $l.menu$i $l.entry$i -side left
            bind $w <Alt-p><Any-KeyPress-$i> "focus $l.entry$i"
            bind $l.entry$i <Alt-s> "$l.menu$i configure -text S"
            bind $l.entry$i <Alt-f> "$l.menu$i configure -text F"
	}
	proc optPeakPolynomialReset {} {
	    global optPeakPolynomial
	    for {set i 0} {$i < 4} {incr i} {
		set optPeakPolynomial($i) 0
		.optPeakParam.background.polynomial.menu$i configure -text F
	    }
	}
	optPeakPolynomialReset

	set e $b.exponential
	frame $e
	pack  $e -side top -pady 2 -fill x -expand 1
        button $e.reset -text Reset -padx 0 -pady 0\
		-command optPeakExponentialReset
	pack  $e.reset -side top -anchor e
	label $e.label -text " eXponential: (N*exp\[mu*x\])" -underline 2
	place $e.label -anchor nw -x 0 -y 0
	foreach i {N mu} {
	    label $e.label_$i -text "     $i:"
	    set m $e.menu_$i.m
	    menubutton $e.menu_$i -menu $m\
		    -padx 0 -pady 0 -relief raised -width 2
	    entry $e.entry_$i -width 12 -textvariable optPeakExponential($i)
	    menu  $m -tearoff 0
	    $m add command -label Search -underline 0 -command\
		    "$e.menu_$i configure -text S"
	    $m add command -label Fix    -underline 0 -command\
		    "$e.menu_$i configure -text F"
            pack  $e.label_$i $e.menu_$i $e.entry_$i -side left
            bind $w <Alt-x><Alt-[string index [string tolower $i] 0]>\
                    "focus $e.entry_$i"
            bind $e.entry_$i <Alt-s> "$e.menu_$i configure -text S"
            bind $e.entry_$i <Alt-f> "$e.menu_$i configure -text F"
	}
	proc optPeakExponentialReset {} {
	    global optPeakExponential
            foreach i {N mu} {
                set optPeakExponential($i) 0
		.optPeakParam.background.exponential.menu_$i configure -text F
            }
	}
	optPeakExponentialReset

        set h $b.histogram
        frame $h
        pack  $h -side top -pady 2 -fill x -expand 1
        button $h.reset -text Reset -padx 0 -pady 0\
		-command optPeakHistogramReset
	pack  $h.reset -side top -anchor e
        label $h.label -text " Histogram:" -underline 1
	place $h.label -anchor nw -x 0 -y 0
        label $h.label_ID -text "     ID:"
        entry $h.entry_ID -width 16 -textvariable optPeakHistogram(ID)
	button $h.button -image imageLEFT -padx 0\
		-command "set optPeakHistogram(ID)\
		\[lindex \$histList \[.hist.listbox index active\]\]"
        label $h.label_factor -text " factor:"
        set m $h.menu.m
        menubutton $h.menu -menu $m\
                -padx 0 -pady 0 -relief raised -width 2
        entry $h.entry_factor -width 10 -textvariable optPeakHistogram(factor)
        menu  $m -tearoff 0
        $m add command -label Search -underline 0 -command\
                "$h.menu configure -text S"
        $m add command -label Fix    -underline 0 -command\
                "$h.menu configure -text F"
        pack  $h.label_ID $h.entry_ID $h.button\
		$h.label_factor $h.menu $h.entry_factor -side left
	bind $w <Alt-h><Alt-i> "focus $h.entry_ID"
	bind $w <Alt-h><Alt-f> "focus $h.entry_factor"
	bind $h.entry_factor <Alt-s> "$h.menu configure -text S"
	bind $h.entry_factor <Alt-f> "$h.menu configure -text F"
	set L .hist.listbox
	set I $h.entry_ID
	bind $I <KP_Enter>  "$h.button invoke"
	bind $I <Up>        "tkListboxUpDown $L -1"
	bind $I <Down>      "tkListboxUpDown $L  1"
	bind $I <Control-p> "tkListboxUpDown $L -1"
	bind $I <Control-n> "tkListboxUpDown $L  1"
	bind $I <Shift-Up>  "tkListboxExtendUpDown $L -1"
	bind $I <Shift-Down> "tkListboxExtendUpDown $L  1"
	bind $I <Alt-less>  {histListboxSelect "0" ""}
	bind $I <Alt-greater> {histListboxSelect "end" ""}
	bind $I <Prior>     {histListboxSelect "@0,0" "yview scroll -1 pages"}
	bind $I <Next>      {histListboxSelect "@0,0" "yview scroll  1 pages"}
	bind $I <Alt-v>     {histListboxSelect "@0,0" "yview scroll -1 pages"}
	bind $I <Control-v> {histListboxSelect "@0,0" "yview scroll  1 pages"}
	proc optPeakHistogramReset {} {
	    global optPeakHistogram
            set optPeakHistogram(ID) ""
            set optPeakHistogram(factor) 0
            .optPeakParam.background.histogram.menu configure -text F
	}
	optPeakHistogramReset

	set b $w.buttons
	frame $b
	pack  $b -side bottom -pady 1m
	button $b.ok       -text "Ok" -padx 0 -pady 0\
		-command {.optPeakFit.buttons.ok invoke}
	button $b.basic    -text "Basic Param" -underline 0 -padx 0 -pady 0\
		-command {focus .optPeakFit}
	button $b.allreset -text "All Reset" -underline 0 -padx 0 -pady 0\
		-command {optPeakParamReset; optPeakPolynomialReset;\
		optPeakExponentialReset; optPeakHistogramReset}
	button $b.cancel   -text "Cancel" -padx 0 -pady 0\
		-command "catch {wm withdraw .optPeakFit}; wm withdraw $w"
	pack  $b.ok $b.basic $b.allreset $b.cancel -side left -padx 2m
	bind  $w <Alt-b>  "$b.basic    invoke"
	bind  $w <Alt-a>  "$b.allreset invoke"
	bind  $w <Escape> "$b.cancel   invoke"

	wm withdraw $w
	update idletasks
	set x [expr   [winfo screenwidth  $w]/4 - [winfo reqwidth  $w]/2 \
		- [winfo vrootx [winfo parent $w]]]
	set y [expr 3*[winfo screenheight $w]/4 - [winfo reqheight $w]/2 \
		- [winfo vrooty [winfo parent $w]]]
	wm geom $w +$x+$y
    }

    wm deiconify $w
}

proc optPeakParamOut {} {
    global histList optPeakStatus optPeakParameter\
	   optPeakPolynomial optPeakExponential optPeakHistogram
    set w .optPeakParam
    set p $w.peak
    for {set i 1} {$i < 9} {incr i} {
	set v $p.param$i
	if $optPeakStatus($i) {
	    foreach j {amplitude centroid width ratio} {
		if ![CheckNumInput $optPeakParameter($i,$j)\
			"$j of Peak#$i" $v.${j}Entry] {return 0}
		if {[$v.${j}Menu cget -text] == "C"} {
		    if     {$optPeakParameter($i,$j) <= 0 ||\
			    $optPeakParameter($i,$j) >  8 ||\
			    $optPeakParameter($i,$j) == $i ||\
			    !$optPeakStatus($optPeakParameter($i,$j))} {
			tk_dialog .error "Illigal Common Number"\
				"Illigal Common Number" error 0 OK
			focus $v.${j}Entry
			return 0
		    }
		}
	    }
	}
    }
    set l $w.background.polynomial
    for {set i 0} {$i < 4} {incr i} {
	if ![CheckNumInput $optPeakPolynomial($i)\
		"Coef.-$i of Polynomial Background" $l.entry$i] {return 0}
    }
    set e $w.background.exponential
    foreach i {N mu} {
	if ![CheckNumInput $optPeakExponential($i)\
		"$i of Exponential Background" $e.entry_$i] {return 0}
    }
    set h $w.background.histogram
    if ![CheckNumInput $optPeakHistogram(factor)\
	    "factor of Histogram Background" $h.entry_factor] {return 0}
    if {$optPeakHistogram(ID) != ""} {
	if [regexp {^ *[0-9]+ *$} $optPeakHistogram(ID)] {
	    if {$optPeakHistogram(ID) < 1 ||\
		    $optPeakHistogram(ID) > [llength $histList]} {
		tk_dialog .error "Illigal HistID" "Illigal\
			Histogram ID($optPeakHistogram(ID))" error 0 OK
		focus $h.entry_ID
		return 0
	    }
            set hl [expr $optPeakHistogram(ID)-1]
	} {
	    if {[set hl [lsearch -exact $histList\
		    [string toupper $optPeakHistogram(ID)]]] == -1} {
		tk_dialog .error "Illigal HistID" "Illigal\
			Histogram ID($optPeakHistogram(ID))" error 0 OK
		focus $h.entry_ID
		return 0
	    }
	}
        regsub {^ *[0-9]+: *[A-Z0-9!#$&'()+\-\.^_~]+ *([12])D( |\*).*$}\
                [.hist.listbox get $hl] {\1} ndim
        if {$ndim != 1} {
            tk_dialog .error "Not 1-dim Hist"\
                    "Hist($optPeakHistogram(ID)) is not 1-dim." error 0 OK
            focus $h.entry_ID
            return 0
        }
    }
    H Option Peak Reset
    for {set i 1} {$i < 9} {incr i} {
	if $optPeakStatus($i) {
	    set v $p.param$i
	    set cmd [list $i]
	    foreach j {amplitude centroid width ratio} {
                lappend cmd [$v.${j}Menu cget -text] $optPeakParameter($i,$j)
            }
	    H Option Peak Parameter $cmd
	}
    }
    set cmd {}
    for {set i 0} {$i < 4} {incr i}\
            {lappend cmd [$l.menu$i cget -text] $optPeakPolynomial($i)}
    if {$cmd != {F 0 F 0 F 0 F 0}} {H Option Peak Polynomial $cmd}
    set cmd {}
    foreach i {N mu}\
            {lappend cmd [$e.menu_$i cget -text] $optPeakExponential($i)}
    if {$cmd != {F 0 F 0}} {H Option Peak Exponential $cmd}
    if {$optPeakHistogram(ID) != ""} {
	H Option Peak Histogram $optPeakHistogram(ID)\
		[$h.menu cget -text] $optPeakHistogram(factor)
    }
    return 1
}

#--------------------------------------------------------------

set m $root.assign
menu $m
$m add command -label Function  -underline 0 -command optAssignFunc
source [LibDir assign.tcl]
$m add command -label Deassign  -underline 0 -command {
    if [checkCmdline] {H Option Assign Deassign $cmdline}
    set cmdline ""
}
set w .assignFncOutput
$m add command -label "Hist<=Func" -underline 0\
	-command "AssignFncOutput $w \"Create histogram(s) of function(s)
\tassigned to\" \"Root name\" 24 Histogram"
$m add command -label "WriteFunc" -underline 0\
	-command "AssignFncOutput $w \"Write function(s) assigned to\"\
	\"File name\" 32 WriteFile"
frame $w -relief raised -bd 2
pack [frame [set b $w.buttons]] -side bottom -fill x -expand 1 -pady 1m
pack [label [set t $w.title  ]] -side top   -anchor nw -padx 1m -pady 1m
pack [label [set l $w.label  ]] -side left  -anchor nw -padx 1m
pack [entry [set e $w.entry  ]] -side right -anchor nw -padx 1m
pack [button $b.ok -text Ok] [button $b.cancel -text Cancel]\
	-side left -expand 1 -padx 1m -pady 0m
bind $e <Return> "$b.ok     invoke"
bind $e <Escape> "$b.cancel invoke"
proc AssignFncOutput {w title label width command} {
    global ActiveEntry
    uplevel #0 {set cmdline ""}
    [set b $w.buttons].cancel configure -command "grab release $w;\
	    set ActiveEntry $ActiveEntry; focus [focus]; place forget $w"
    if ![regexp {^ *[0-9]+: *([A-Z0-9!#$&'()+\-\.^_~]+) *[12]D\*}\
	    [.hist.listbox get active] dummy hist] {
	$b.cancel invoke
	tk_dialog .error "FuncAssign Error"\
		"Function is not assigned." error 0 OK
	return 1
    }
    $w.title configure -text "$title \"$hist\""
    $w.label configure -text $label:
    [set e $w.entry] configure -width $width
    $e delete 0 end
    $b.ok configure -command\
	    "H Option Assign $command $hist '\[$e get\]'; $b.cancel invoke"
    set h .hist
    update
    place $w -x [expr [winfo x $h]+ [winfo width  $h]-[winfo reqwidth  $w]]\
	     -y [expr [winfo y $h]+([winfo height $h]-[winfo reqheight $w])/2]
    focus [set ActiveEntry $e]
    grab set $w
}

#--------------------------------------------------------------

set m $root.user
menu $m
source [LibDir user.tcl]

#--------------------------------------------------------------

proc genOption {w title man fit specific command} {
# man = 0: no-destin., 1/2: 1/2-dim required, 3: ignore dim.
#       negative: no-comments
    global ActiveEntry histList optSource optDestin\
	   optRangeLower optRangeUpper optResidue optResultFile optResultMask\
	   optCommentTop optCommentX optCommentY optCommentZ optCursorWidget

    set s $w.source
    set d $w.destin
    set f $w.fit
    set p $w.param
    set b $w.buttons

    if ![winfo exists $w] {
	toplevel $w
	wm title    $w "Polly/Option($title)"
	wm iconname $w "Polly/Option($title)"

	set e $s.entry
	set l .hist.listbox

	frame  $w.spacer -height 1m
	pack   $w.spacer -side top
	frame  $s -relief groove -borderwidth 2
	pack   $s -side top -fill x -expand 1 -padx 1m -pady 1
	label  $s.label  -text Source:\t -underline 0
	entry  $s.entry  -textvariable optSource -width 18
	button $s.button -image imageLEFT -padx 0 -command "\
		set optSource \[lindex \$histList \[$l index active\]\];\
		if $man {OptGetComments [expr abs($man)]};\
		if $fit {H Option Fit Information \$optSource}"
	pack   $s.label $s.entry $s.button -side left -anchor w -pady 1
	bind   $w <Alt-s> "focus $s.entry"
	proc OptGetComments ndim {
	    global optSource histList\
		   optCommentTop optCommentX optCommentY optCommentZ
            H Option Manipulate Information $optSource $ndim
	    set i [lsearch -exact $histList $optSource]
	    if {$i != -1} {
		regsub {^ *[0-9]+: *[A-Z0-9!#$&'()+\-\.^_~]+ *[12]D( |\*)(.*)$}\
			[.hist.listbox get $i] {\2} title
		set list [split [string trim $title] ";"]
		set optCommentTop [lindex $list 0]
		set optCommentX   [lindex $list 1]
		set optCommentY   [lindex $list 2]
		set optCommentZ   [lindex $list 3]
	    }
	}

	if $man {
	    frame $d -relief groove -borderwidth 2
	    pack  $d -side top -fill x -expand 1 -padx 1m -pady 1
	    set   dn $d.name
	    frame $dn
	    pack  $dn -side top -fill x -expand 1 -pady 1
	    label $dn.label -text Destin.:\t -underline 0
	    entry $dn.entry -textvariable optDestin -width 18
	    button $dn.button -image imageLEFT -padx 0\
		    -command "set optDestin ~\$optSource"
	    pack  $dn.label $dn.entry $dn.button -side left -anchor w
	    bind  $w <Alt-d> "focus $dn.entry"
	    bind  $dn.entry <Alt-d> "$dn.button invoke"
	    if {$man > 0} {
		label $d.label -text "Comments..." -underline 0
		pack  $d.label -side top -anchor w
		foreach i {Top X Y Z} {
		    set dw $d.[string tolower $i]
		    frame $dw
		    pack  $dw -side top -fill x -expand 1
		    label $dw.label -text "    $i:\t"
		    entry $dw.entry -textvariable optComment$i -width 25
		    pack  $dw.label -side left -anchor w
		    pack  $dw.entry -fill x -expand 1
		    bind  $w <Alt-c><Alt-[string range\
			    [string tolower $i] 0 0]> "focus $dw.entry"
		}
	    }
	}

	if $fit {
	    frame $f -relief groove -borderwidth 2
	    pack  $f -side top -fill x -expand 1 -padx 1m -pady 1
            set r $f.cursor
            frame $r
            pack  $r -side top -fill x -expand 1
	    label $r.label -text Range:
	    pack  $r.label -side left -anchor w
            for {set i 7} {$i > 0} {incr i -2} {
                button $r.pair$i -text "C.$i-[expr $i+1]" -padx 2 -pady 0
                pack $r.pair$i -side right -anchor e
                bind $w <Alt-KeyPress-$i>          "$r.pair$i invoke"
                bind $w <Alt-KeyPress-[expr $i+1]> "$r.pair$i invoke"
            }
	    set r $f.range
	    frame $r
	    pack  $r -side top -padx 2m
	    label $r.llabel -text Lower -underline 0
	    entry $r.lentry -textvariable optRangeLower -width 10
	    label $r.ulabel -text Upper -underline 0
	    entry $r.uentry -textvariable optRangeUpper -width 10
	    pack  $r.llabel $r.lentry $r.ulabel $r.uentry -side left
	    bind  $w <Alt-l> "focus $r.lentry"
	    bind  $w <Alt-u> "focus $r.uentry"
	    set r $f.residue
	    frame $r
	    pack  $r -side top -anchor w
	    label $r.label -text Residue:\t -underline 0
	    entry $r.entry -textvariable optResidue -width 18
	    pack  $r.label $r.entry -side left -pady 2
	    bind  $w <Alt-r> "focus $r.entry"
	    set r $f.result
	    frame $r
	    pack  $r -side top -anchor w
	    label $r.label -text ResltFile:\t -underline 5
	    entry $r.entry -textvariable optResultFile -width 18
	    button $r.browse -text Browse -padx 1 -pady 0\
		    -command {genFile .optResultFile "Polly/Result"\
		    optResultMask optResultTemp 0 optResultFileExit 1}
	    proc optResultFileExit target\
		    {global optResultFile; set optResultFile $target }
	    pack  $r.label $r.entry $r.browse -side left -anchor w -pady 2
	    bind  $r.entry <Down> "$r.browse invoke"
	    bind  $r.entry <Control-n> "$r.browse invoke"
	    bind  $w <Alt-f> "focus $r.entry"
	}

	frame $b
	pack  $b -padx 1m -pady 1m -side bottom

	frame $p -relief groove -borderwidth 2
	pack  $p -padx 1m -pady 1 -fill both -expand 1

	eval $specific

	button $b.ok     -text "OK"
	button $b.cancel -text "Cancel"
	pack   $b.ok $b.cancel -side left -padx 4m
	bind $w <Return> "$b.ok     invoke"
	bind $w <Escape> "$b.cancel invoke"

	bind $e <KP_Enter>  "$s.button invoke"
	bind $e <Up>        "tkListboxUpDown $l -1"
	bind $e <Down>      "tkListboxUpDown $l  1"
	bind $e <Control-p> "tkListboxUpDown $l -1"
	bind $e <Control-n> "tkListboxUpDown $l  1"
	bind $e <Shift-Up>  "tkListboxExtendUpDown $l -1"
	bind $e <Shift-Down> "tkListboxExtendUpDown $l  1"
	bind $e <Alt-less>  {histListboxSelect "0" ""}
	bind $e <Alt-greater> {histListboxSelect "end" ""}
	bind $e <Prior>     {histListboxSelect "@0,0" "yview scroll -1 pages"}
	bind $e <Next>      {histListboxSelect "@0,0" "yview scroll  1 pages"}
	bind $e <Alt-v>     {histListboxSelect "@0,0" "yview scroll -1 pages"}
	bind $e <Control-v> {histListboxSelect "@0,0" "yview scroll  1 pages"}

	wm withdraw $w
	update idletasks
	set x [expr [winfo screenwidth  $w]/2 - [winfo reqwidth  $w]/2 \
		- [winfo vrootx [winfo parent $w]]]
	set y [expr [winfo screenheight $w]/2 - [winfo reqheight $w]/2 \
		- [winfo vrooty [winfo parent $w]]]
	wm geom $w +$x+$y
    }

    $w.buttons.ok     configure -command\
            "if \[OptCheckNames $w $man $fit\]\
		{uplevel #0 {$command}; $w.buttons.cancel invoke} {}"
    $w.buttons.cancel configure -command\
	    "focus [focus];\
	     set ActiveEntry .cmdline.entry;\
             catch {wm withdraw .optResultFile};\
	     wm withdraw $w"
    if {$fit == 2} {
	optPeakParam
	$w.buttons.cancel configure -command\
		"[$w.buttons.cancel cget -command];\
		catch {wm withdraw .optPeakParam}"
    }
    proc OptCheckNames {w man fit} {
        global histList optSource optDestin\
	       optRangeLower optRangeUpper optResidue
        if {$optSource == ""}\
		{set optSource [lindex $histList [.hist.listbox index active]]}
        regsub {^ *[0-9]+: *[A-Z0-9!#$&'()+\-\.^_~]+ *([12])D( |\*).*$}\
                [.hist.listbox get [lsearch -exact $histList $optSource]]\
                {\1} ndim
	if $man {
            if {[set nd [expr abs($man)]] < 3} {
                if {$nd != $ndim} {
                    tk_dialog .error "Not $nd-DIM"\
                            "Histogram is not $nd-dimensional" error 0 OK
                    return 0
                }
            }
	    if ![CheckNewHist optDestin]\
		    {focus $w.destin.name.entry; return 0}
	}
        if $fit {
	    if {$ndim != 1} {tk_dialog .error "Not 1-DIM"\
		    "Histogram is not 1-dimensional" error 0 OK; return 0}
	    set f $w.fit; set r $f.range
	    if ![CheckNumInput\
		    $optRangeLower "Lower Limit" $r.lentry] {return 0}
	    if ![CheckNumInput\
		    $optRangeUpper "Upper Limit" $r.uentry] {return 0}
	    if {$optResidue != ""} {
		if ![CheckNewHist optResidue] {focus $f.rentry; return 0}
	    }
	}
	return 1
    }

    set optCursorWidget $w.fit.cursor
    set optSource  ""
    set optDestin  ""
    set optResidue ""
    set optResultFile ""
    if ![info exists optResultMask] {set optResultMask [pwd]/*.res}
    $s.button invoke

    wm deiconify $w
    set ActiveEntry $s.entry
    focus $ActiveEntry
}

proc OptComments {} {
    global histList optSource\
	   optCommentTop optCommentX optCommentY optCommentZ
    regsub {^ *[0-9]+: *[A-Z0-9!#$&'()+\-\.^_~]+ *([12])D( |\*).*$}\
	    [.hist.listbox get [lsearch -exact $histList $optSource]]\
	    {\1} ndim
    switch -- $ndim {
	1 {return '$optCommentTop\;$optCommentX\;$optCommentY@'}
	2 {return '$optCommentTop\;$optCommentX\;$optCommentY\;$optCommentZ@'}
    }
}

proc CheckNumInput {value name focus} {
    if {$value == ""} {
	tk_dialog .error "Empty Input" "$name is Empty" error 0 OK
	focus $focus
	return 0
    }
    if ![scan [string trim $value] "%f" dummy] {
	tk_dialog .error "Illigal Format"\
		"Numerical Format Error\nin $name" error 0 OK
	focus $focus
	return 0
    }
    return 1
}

#--------------------------------------------------------------

set optSetCursor 1
