      subroutine optfit
      parameter (nkey=7)
      integer   cmdrd,prmrd
      character keylst(nkey)*12,key*80
      data keylst/'POLYNOMIAL'  ,'GAUSSIAN'    ,'LORENTZIAN'  ,
     &            'EXPONENTIAL' ,'HISTOGRAM'   ,'USERFUNC'    ,
     &            'INFORMATION' /

01000 icmd=cmdrd(nkey,keylst,key)
      goto (10000,20000,30000,40000,50000,60000,80000) icmd
      write(6,'(3A)') '! Command Error "',key(:length(key)),'".'
      goto 09100
09000 write(6,'(2A)') '! Operand Error in Option-Fit-',keylst(icmd)
09100 i=prmrd(key,1)
09900 call flush(6)
      return
c     Polynomial
10000 call opftpl
      goto 09900
c     Gaussian
20000 call opftgn(1)
      goto 09900
c     Lorentzian
30000 call opftgn(2)
      goto 09900
c     Exponential
40000 call opftex
      goto 09900
c     Histogram
50000 call opfths
      goto 09900
c     User-Function
60000 goto 09000
c     Information
80000 call opftif
      goto 09900
      end

      subroutine opftpl(*)
c     Polynomial Fitting: param=(Hist, Lower, Upper, Norder [,RESIDU])
      integer*4 prmrd
      character key*80,hstnam*16,rsdnam*16
      parameter (maxord=10)
      real*4    prm(0:maxord),dprm(0:maxord)
      real*4    plfset,plfval,plfdrv
      external  plfset,plfval,plfdrv
      data lastid/0/
      if (prmrd(key,0).ne.0) goto 91000
      call hlkup(key,id,*90000)
      if (prmrd(key,0).ne.0) goto 91000
      read(key,*,err=90000) xmin
      if (prmrd(key,0).ne.0) goto 91000
      read(key,*,err=90000) xmax
      if (prmrd(key,0).ne.0) goto 91000
      read(key,*,err=90000) norder
      if (norder.lt.0.or.norder.gt.maxord) goto 90000
      rsdnam=' '
      idmmy=prmrd(rsdnam,1)
      call curfit(id,xmin,xmax,1.E-6,2000,plfset,plfval,plfdrv,
     &            norder+1,prm,dprm,chisqr,nfree,*99000)
      if (lastid.ne.0) call hoptn('RES,NFUNC',0,lastid)
      call hoptn('FUNC',plfval,id)
      lastid=id
      key=hstnam(id)
      write(6,'(A)')    '<< RESULT >>'
      write(6,'(2A)')   'Polynimial Fit to ',key(:length(key))
      call parff2(xmin,xmax,key,l)
      write(6,'(2A)')   'Range = ',key(:l)
      write(6,'(A,I3)') 'Order =',norder
      write(6,'(A,1pE10.3,A,I5)')
     &                  'Chi**2 =',chisqr,'  Freedom =',nfree
      write(key,'(3A16)') 'Order#   ','Coefficient','Sigma    '
      write(6,'(A)') key(3:length(key))
      do i=0,norder
         write(key(1:16),'(I8)') i
         call frefrm(prm (i),key(17:32),l)
         call frefrm(dprm(i),key(33:48),l)
         write(6,'(A)') key(:32+l)
      enddo
      write(6,'(A)')    '<< EOF >>'
      if (rsdnam.eq.' ') goto 80000
      call crehst(id,idrsd,rsdnam,'E*4 ','Residu',*99000)
      call calrsd(idrsd,id,xmin,xmax,plfval)
80000 call hlist	! for '*'-mark
      return
90000 i=prmrd(key,1)	! read remaining line
91000 write(6,'(A)') '! Illigal Parameter in Option Fit-Polynomial'
99000 return 1
      end

      function plfval(x)
      real*4    prm(0:10),prm2(0:*),derive(*)
      plfval=0.
      v=1.
      do j=0,norder
         plfval=plfval+v*prm(j)
         v=v*x
      enddo
      return
      entry plfdrv(x,derive,nprm)
      v=1.
      do j=1,nprm
         derive(j)=v
         v=v*x
      enddo
      plfdrv=0.
      return
      entry plfset(prm2,n)
      norder=n-1
      do j=0,norder
         prm(j)=prm2(j)
      enddo
      plfset=0.
      return
      end

      subroutine opftgn(itype,*)
c     itype 1= Gaussian   Fitting,  A*exp(-(x-m)/2/s**2), w=s*2.35
c           2= Lorentzian Fitting,  A/((x-m)**2+(w/2)**2)
c     param=(Hist, Lower, Upper [,SetCursor, RESIDU])
      integer*4 prmrd,hbinx,nb(2),setcsr
      character key*80,hstnam*16,rsdnam*16,prmnam(4,2)*9
      real*4    prm(4),dprm(4),stat(0:22),xl(2),xw(2)
      real*4    gafset,gafval,gafdrv,lzfset,lzfval,lzfdrv
      external  gafset,gafval,gafdrv,lzfset,lzfval,lzfdrv
      parameter (sig2fw=2.35482)	! 2*sqrt(2*ln(2))
      data lstgid,lstlid/2*0/
      data prmnam/'Amplitude','Centroid','Sigma','FWHM',
     &            'Amplitude','Centroid','FWHM',' '/
      if (prmrd(key,0).ne.0) goto 91000
      call hlkup(key,id,*90000)
      if (prmrd(key,0).ne.0) goto 91000
      read(key,*,err=90000) xmin
      if (prmrd(key,0).ne.0) goto 91000
      read(key,*,err=90000) xmax
      setcsr=0
      rsdnam=' '
      if (prmrd(key,0).ne.0) goto 01000
      read(key,*,err=90000) setcsr
      idmy=prmrd(rsdnam,1)
01000 key=hstnam(id)
      call nargset(7)
      call hget (id,'GET ',nd,nb,ms,xl,xw)
      call nargset(5)
      call hstat(id,'GET ',stat,hbinx(amin1(xmin,xmax)),
     &                          hbinx(amax1(xmin,xmax)))
      goto (10000,20000) itype
10000 prm(1)=stat(1)*xw(1)/sqrt(2.*stat(3))
      prm(2)=stat(2)
      prm(3)=stat(3)
      call curfit(id,xmin,xmax,1.E-6,2000,gafset,gafval,gafdrv,
     &            3,prm,dprm,chisqr,nfree,*99000)
      if (lstgid.ne.0) call hoptn('RES,NFUNC',0,lstgid)
      call hoptn('FUNC',gafval,id)
      lstgid=id
      prm (4)=sig2fw* prm(3)
      dprm(4)=sig2fw*dprm(3)
      write(6,'(A)')    '<< RESULT >>'
      write(6,'(2A)')   'Single Gaussian Fit to ',key(:length(key))
      goto 40000
20000 prm(3)=stat(3)*sig2fw
      prm(2)=stat(2)
      prm(1)=stat(1)*xw(1)*prm(3)/2./3.1415
      call curfit(id,xmin,xmax,1.E-6,2000,lzfset,lzfval,lzfdrv,
     -            3,prm,dprm,chisqr,nfree,*99000)
      if (lstlid.ne.0) call hoptn('RES,NFUNC',0,lstlid)
      call hoptn('FUNC',lzfval,id)
      lstlid=id
      write(6,'(A)')    '<< RESULT >>'
      write(6,'(2A)')   'Single Lorentzian Fit to ',key(:length(key))
40000 call parff2(xmin,xmax,key,l)
      write(6,'(2A)')   'Range = ',key(:l)
      write(6,'(A,1pE10.3,A,I5)')
     &                  'Chi**2 =',chisqr,'  Freedom =',nfree
      do i=1,5-itype
         call frefrm(prm (i),key( 1:16),l)
         call frefrm(dprm(i),key(17:32),l)
         write(6,'(4x,3A)') key(:32),'# ',prmnam(i,itype)
      enddo
      write(6,'(A)')    '<< EOF >>'
      if (setcsr.ne.0) then
         call crsrmn(id,1,2,1,prm(2))
         do i=2,8
            call crsrmn(id,i,2,0,0.)
         enddo
      endif
      if (rsdnam.eq.' ') goto 88000
      call crehst(id,idrsd,rsdnam,'E*4 ','Residu',*99000)
      goto (81000,82000) itype
81000 call calrsd(idrsd,id,xmin,xmax,gafval)
      goto 88000
82000 call calrsd(idrsd,id,xmin,xmax,lzfval)
88000 call hlist	! for '*'-mark
      return
90000 i=prmrd(key,1)	! read remaining line
91000 write(6,'(A)') '! Illigal Parameter in Option Fitting.'
99000 return 1
      end

      function gafval(x)
      real*4    x,prm(3),prm2(n),derive(n)
      w=(x-prm(2))/prm(3)
      gafval=0.
      if (w.lt.10.) gafval=prm(1)*exp(-w*w/2.)
      return
      entry gafdrv(x,derive,n)
      w=(x-prm(2))/prm(3)
      derive(1)=0.
      if (w.lt.10.)
     &derive(1)=exp(-w*w/2.)
      derive(2)=prm(1)*derive(1)*w/prm(3)
      derive(3)=derive(2)*w
      gafdrv=0.
      return
      entry gafset(prm2,n)
      if (prm2(3).le.0.) prm2(3)=abs(prm2(3))
      prm(1)=prm2(1)
      prm(2)=prm2(2)
      prm(3)=prm2(3)
      gafset=0.
      return
      end

      real function lzfval(x)
      real*4    x,prm(3),prm2(n),derive(n),lzfdrv,lzfset
      lzfval=prm(1)/((x-prm(2))**2+(prm(3)/2.)**2)
      return
      entry lzfdrv(x,derive,n)
      derive(1)=1./((x-prm(2))**2+(prm(3)/2.)**2)
      derive(2)= prm(1)*(x-prm(2))*2.*derive(1)**2
      derive(3)=-prm(1)*   prm(3) /2.*derive(1)**2
      lzfdrv=0.
      return
      entry lzfset(prm2,n)
      if (prm2(3).le.0.) prm2(3)=abs(prm2(3))
      prm(1)=prm2(1)
      prm(2)=prm2(2)
      prm(3)=prm2(3)
      lzfset=0.
      return
      end

      subroutine opftex(*)
c     Exponential+const_back Fitting
c     param = (Hist, Lower, Upper, NeXponent [,Const-Back ,RESIDU])
      integer*4 prmrd,cnstbk,bool10
      character key*80,hstnam*16,rsdnam*16,prmnam(3)*9
      parameter (maxexp=5)
      real*4    prm(2*maxexp+1),dprm(2*maxexp+1)
      real*4    exffnc,exfset,exfval,exfdrv
      external  exffnc,exfset,exfval,exfdrv
      data lastid/0/,prmnam/'Amplitude','X-factor','Half-Life'/
      if (prmrd(key,0).ne.0) goto 91000
      call hlkup(key,id,*90000)
      if (prmrd(key,0).ne.0) goto 91000
      read(key,*,err=90000) xmin
      if (prmrd(key,0).ne.0) goto 91000
      read(key,*,err=90000) xmax
      if (prmrd(key,0).ne.0) goto 91000
      read(key,*,err=90000) nexpnt
      cnstbk=0
      rsdnam=' '
      if (prmrd(key,0).ne.0) goto 10000
      read(key,*,err=90000) cnstbk
      if (cnstbk.ne.0) cnstbk=1
      idmmy=prmrd(rsdnam,1)
10000 call nargset(3)
      call hget(id,'GET ',nd)
      if (nd.ne.1) goto 92000
      call sgexft(id,xmin,xmax,pa,pb,*99000)
      do i=1,nexpnt
         prm(2*i-1)=pa/i
         prm(2*i  )=pb*i
      enddo
      if (cnstbk.ne.0) prm(2*nexpnt+1)=0.
      call curfit(id,xmin,xmax,1.E-6,2000,exfset,exfval,exfdrv,
     &            2*nexpnt+cnstbk,prm,dprm,chisqr,nfree,*99000)
      if (lastid.ne.0) call hoptn('RES,NFUNC',0,lastid)
      call hoptn('FUNC',exffnc,id)
      call hoptn('NFUNC',cnstbk+nexpnt
     &                  +bool10(cnstbk.ne.0.or.nexpnt.gt.1),id)
      lastid=id
      key=hstnam(id)
      write(6,'(A)')    '<< RESULT >>'
      write(6,'(2A)')   'eXponential Fit to ',key(:length(key))
      call parff2(xmin,xmax,key,l)
      write(6,'(2A)')   'Range = ',key(:l)
      write(6,'(A,I2)') 'eXponent No. =',nexpnt
      if (cnstbk.ne.0)
     &write(6,'(A)')    '         and Constant Background'
      write(6,'(A,1pE10.3,A,I5)')
     &                  'Chi**2 =',chisqr,'  Freedom =',nfree
      do i=1,nexpnt
         do j=1,3
	    if (j.le.2) then
               call frefrm(prm ((i-1)*2+j),key( 1:16),l)
               call frefrm(dprm((i-1)*2+j),key(17:32),l)
	    else
               call frefrm(-log(2.)/prm (i*2)            ,key( 1:16),l)
               call frefrm( log(2.)*dprm(i*2)/prm(i*2)**2,key(17:32),l)
	    endif
	    write(6,'(4x,3A,1H#,I1)') key(:32),'# ',prmnam(j),i
         enddo
      enddo
      if (cnstbk.ne.0) then
         call frefrm(prm (nexpnt*2+1),key( 1:16),l)
         call frefrm(dprm(nexpnt*2+1),key(17:32),l)
         write(6,'(4x,2A)') key(:32),'# Const. Background'
      endif
      write(6,'(A)')    '<< EOF >>'
      if (rsdnam.eq.' ') goto 80000
      call crehst(id,idrsd,rsdnam,'E*4 ','Residu',*99000)
      call calrsd(idrsd,id,xmin,xmax,exfval)
80000 call hlist	! for '*'-mark
      return
90000 i=prmrd(key,1)	! read remaining line
91000 write(6,'(A)') '! Illigal Parameter in Option Fit-Exponential'
      goto 99000
92000 write(6,'(A)') '# Not 1-DIM Histogram.'
99000 return 1
      end

      function exffnc(x,i)
      parameter (maxexp=5)
      real*4    x,prm(2*maxexp+1),prm2(*),derive(*)
      if (i.eq.nprm/2+mod(nprm,2)+1) goto 10000
      if (i.eq.nprm/2+1) then	! background
         exffnc=prm(nprm)
      else
         exffnc=prm(2*i-1)*exp(amin1(prm(2*i)*x,50.))
      endif
      return
      entry exfval(x)
10000 exfval=0.
      do j=0,2*(nprm/2)-1,2
         exfval=exfval+prm(j+1)*exp(amin1(prm(j+2)*x,50.))
      enddo
      if (mod(nprm,2).ne.0) exfval=exfval+prm(nprm)
      return
      entry exfdrv(x,derive,n)
      do j=0,2*(n/2)-1,2
         derive(j+1)=exp(amin1(prm(j+2)*x,50.))
         derive(j+2)=prm(j+1)*x*derive(j+1)
      enddo
      if (mod(n,2).ne.0) derive(n)=1.
      exfdrv=0.
      return
      entry exfset(prm2,n)
      nprm=n
      do j=1,n
         if (mod(j,2).eq.0) then
            prm(j)=      prm2(j)	! X-factor
         else
            prm(j)=amax1(prm2(j),0.)	! Amp. or B.G.
         endif
      enddo
      exfset=0.
      return
      end

      subroutine opfths(*)
c     Histogram Conbination Fitting
c     param=(Hist, Lower, Upper, '(' 1st-Hist, 2nd-Hist.. ')'
c           [, Const-Back, Shift, RESIDU])
      integer*4 prmrd,hstrd,cnstbk,shift,bool10
      character key*80,hstnam*16,rsdnam*16
      parameter (maxhst=10)
      integer*4 idf(maxhst)
      real*4    prm(maxhst+2),dprm(maxhst+2)
      real*4    hsffnc,hsfset,hsfval,hsfdrv,hsfini
      external  hsffnc,hsfset,hsfval,hsfdrv
      data lastid/0/
      if (prmrd(key,0).ne.0) goto 91000
      call hlkup(key,id,*90000)
      if (prmrd(key,0).ne.0) goto 91000
      read(key,*,err=90000) xmin
      if (prmrd(key,0).ne.0) goto 91000
      read(key,*,err=90000) xmax
      if (hstrd(key).ne.0) goto 91000
      if (key.ne.'(') then
         nhist=1
         call hlkup(key,idf(nhist),*90000)
      else
         nhist=0
00800    if (hstrd(key).ne.0) goto 91000
         if (key.eq.')') goto 01000
         nhist=nhist+1
         if (nhist.gt.maxhst) goto 90000
         call hlkup(key,idf(nhist),*90000)
         goto 00800
      endif
01000 cnstbk=0
      shift =0
      rsdnam=' '
      if (prmrd(key,0).ne.0) goto 10000
      read(key,*,err=90000) cnstbk
      if (cnstbk.ne.0) cnstbk=1
      if (prmrd(key,0).ne.0) goto 10000
      read(key,*,err=90000) shift
      if (shift .ne.0) shift =1
      idmmy=prmrd(rsdnam,1)
10000 if (nhist.eq.0) goto 90000
      dummy=hsfini(nhist,idf,cnstbk,shift)
      do i=1,nhist
         prm(i)=1.
      enddo
      if (cnstbk.ne.0) prm(nhist       +1)=0.
      if (shift .ne.0) prm(nhist+cnstbk+1)=0.
      call curfit(id,xmin,xmax,1.E-6,2000,hsfset,hsfval,hsfdrv,
     &            nhist+cnstbk+shift,prm,dprm,chisqr,nfree,*99000)
      if (lastid.ne.0) call hoptn('RES,NFUNC',0,lastid)
      call hoptn( 'FUNC',hsffnc,id)
      call hoptn('NFUNC',nhist+cnstbk
     &                  +bool10(nhist.gt.1.or.cnstbk.ne.0),id)
      lastid=id
      key=hstnam(id)
      write(6,'(A)')    '<< RESULT >>'
      write(6,'(2A)')   'Hist-combination Fit to ',key(:length(key))
      call parff2(xmin,xmax,key,l)
      write(6,'(2A)')   'Range = ',key(:l)
      write(6,'(A,1pE10.3,A,I5)')
     &                  'Chi**2 =',chisqr,'  Freedom =',nfree
      write(key,'(3A16)') 'Order#   ','Coefficient','Sigma    '
      write(6,'(A,2A16)') '   Parameter','Sigma','Meaning'
      do i=1,nhist
         call frefrm(prm (i),key( 1:16),l)
         call frefrm(dprm(i),key(17:32),l)
         key(33:)='# Factor of '//hstnam(idf(i))
         write(6,'(4X,2A,I1)') key(:length(key))
      enddo
      if (cnstbk.ne.0) then
         call frefrm(prm (nhist+1),key( 1:16),l)
         call frefrm(dprm(nhist+1),key(17:32),l)
         write(6,'(4X,2A)') key(:32),'# Constant background'
      endif
      if (shift .ne.0) then
         call frefrm(prm (nhist+cnstbk+1),key( 1:16),l)
         call frefrm(dprm(nhist+cnstbk+1),key(17:32),l)
         write(6,'(4X,2A)') key(:32),'# Shift'
      endif
      write(6,'(A)')    '<< EOF >>'
      if (rsdnam.eq.' ') goto 80000
      call crehst(id,idrsd,rsdnam,'E*4 ','Residu',*99000)
      call calrsd(idrsd,id,xmin,xmax,hsfval)
80000 call hlist	! for '*'-mark
      return
90000 i=prmrd(key,1)	! read remaining line
91000 write(6,'(A)') '! Illigal Parameter in Option Fit-Histograms'
99000 return 1
      end

      function hsffnc(x,i)
      parameter (maxhst=10)
      real*4    prm(maxhst+2),prm2(*),derive(*)
      logical   cnstbk,shift
      integer*4 id(maxhst),id0(*),c1,s1
      real*4    xl(maxhst+1),xw(maxhst+1),xu(maxhst)
      integer*4 nb(maxhst+1),hpntr,hbinx,bool10
      if (i.eq.nhist+bool10(cnstbk)+1) goto 10000
      if (i.le.nhist) then
         x1=x-shiftx
         k=hpntr(id(i))
         k=hbinx(amax1(xl(i),amin1(xu(i),x1)))
         dx=x1-(hx(k)+xw(i)/2.)
         if (dx.gt.0.) then
            hsffnc=prm(i)*(hy(k)+(hy(k+1)-hy(k))*dx/xw(i))
         else
            hsffnc=prm(i)*(hy(k)+(hy(k)-hy(k-1))*dx/xw(i))
         endif
      else
         hsffnc=prm(nhist+1)
      endif
      return
      entry hsfval(x)
10000 hsfval=0.
      x1=x-shiftx
      do j=1,nhist
         k=hpntr(id(j))
         k=hbinx(amax1(xl(j),amin1(xu(j),x1)))
         dx=x1-(hx(k)+xw(j)/2.)
         if (dx.ge.0.) then
            hsfval=hsfval+prm(j)*(hy(k)+(hy(k+1)-hy(k))*dx/xw(j))
         else
            hsfval=hsfval+prm(j)*(hy(k)+(hy(k)-hy(k-1))*dx/xw(j))
         endif
      enddo
      if (cnstbk) hsfval=hsfval+prm(nhist+1)
      return
      entry hsfdrv(x,derive,n)
      x1=x-shiftx
      df=0.
      do j=1,nhist
         k=hpntr(id(j))
         k=hbinx(amax1(xl(j),amin1(xu(j),x1)))
         dx=x1-(hx(k)+xw(j)/2.)
         if (dx.ge.0.) then
            derive(j)=hy(k)+(hy(k+1)-hy(k))*dx/xw(j)
         else
            derive(j)=hy(k)+(hy(k)-hy(k-1))*dx/xw(j)
         endif
         if (shift) df=df-prm(j)*(hy(k+1)-hy(k-1))/(2.*xw(j))
      enddo
      if (cnstbk) derive(nhist+1)=1.
      if (shift ) derive(n      )=df
      hsfdrv=0.
      return
      entry hsfset(prm2,n)
      do j=1,n
         if (n.le.nhist) then
            prm(j)=amax1(prm2(j),0.)
         else
            prm(j)=prm2(j)
         endif
      enddo
      if (shift) shiftx=prm2(n)
      hsfset=0.
      return
      entry hsfini(n,id0,c1,s1)
      do j=1,n
         id (j)=id0 (j)
         call nargset(7)
         call hget(id(j),'GET ',nd,nb(j),ms,xl(j),xw(j))
         xu(j)=xl(j)+xw(j)*(nb(j)-1)
         xl(j)=xl(j)-xw(j)
      enddo
      nhist =n
      cnstbk=(c1.ne.0)
      shift =(s1.ne.0)
      shiftx=0.
      hsfini=0.
      return
      end

      subroutine sgexft(id,xmin,xmax,a,b,*)
c     Single-Exponential Fit
      integer*4 hbinx
      wn=0.
      x1=0.
      x2=0.
      y1=0.
      xy=0.
      call chkcmb(id,*91000)
      call clermn(errmin,id)
      do i=hbinx(amin1(xmin,xmax)),hbinx(amax1(xmin,xmax))
         if (hy(i).gt.0.) then
            wt=1./amax1(errmin,hye(i))**2
            wn=wn+wt
            x1=x1+wt*hx(i)
            x2=x2+wt*hx(i)**2
            y1=y1+wt*log(hy(i))
            xy=xy+wt*hx(i)*log(hy(i))
         endif
      enddo
      if (wn.eq.0.) goto 91000
      dt=wn*x2-x1*x1
      if (dt.eq.0.) goto 92000
      a=exp((x2*y1-x1*xy)/dt)
      b=    (wn*xy-x1*y1)/dt
      return
91000 write(6,'(A)') '# No Data.'
      return 1
92000 write(6,'(A)') '# Fit Error.'
      return 1
      end

      subroutine opftif(*)
c     Information: param=(Hist)
      integer*4 prmrd
      character key*80
      real*4    view(6)
      if (prmrd(key,1).ne.0) goto 91000
      call hlkup(key,id,*91000)
      call nargset(3)
      call hget(id,'GET ',nd)
      call vwman(id,view,1)
      k=1
      do i=1,4
         call frefrm(view(i),key(k:),l)
         k=k+l+1
      enddo
      write(6,'(A/I2,1X,A)') '<< FIT_INFO >>',nd,key(:length(key))
      if (nd.eq.1) then
         do i=1,7,2
            call crsrmn(id,i  ,1,ll,xl,dmy)
            call crsrmn(id,i+1,1,lu,xu,dmy)
            if (ll.eq.1.and.lu.eq.1) then
               call frefrm(xl,key       ,l1)
               call frefrm(xu,key(l1+2:),l2)
               write(6,'(I2,1H ,A)') i,key(:l1+l2+1)
            endif
         enddo
         write(6,'(A)') '<< EOF >>'
      endif
      return
91000 write(6,'(A)') '! Illigal Parameter in Option Fit-Information'
99000 return 1
      end
