      subroutine optpsf
      parameter (nkey=9)
      integer   cmdrd,prmrd
      character keylst(nkey)*12,key*80
      data keylst/'SEARCH','FIT','CONDITION','RESET','PARAMETER',
     &     'POLYNOMIAL','EXPONENTIAL','HISTOGRAM','CURSOR_INFO'/

01000 icmd=cmdrd(nkey,keylst,key)
      goto (11000,12000,13000,14000,15000,16000,17000,18000,19000) icmd
      write(6,'(3A)') '! Command Error "',key(:length(key)),'".'
      goto 09100
09000 write(6,'(2A)') '! Operand Error in Opt-Peak-',keylst(icmd)
09100 i=prmrd(key,1)
09900 call flush(6)
      return
c     Search
11000 call oppksc
      goto 09900
c     Fit
12000 call oppkft
      goto 09900
c     Condition
13000 call oppkco
      goto 09900
c     Reset
14000 call oppkrs
      goto 09900
c     Parameter
15000 call oppkpr
      goto 09900
c     Polynomial
16000 call oppkpl
      goto 09900
c     Exponential
17000 call oppkex
      goto 09900
c     Histogram
18000 call oppkhs
      goto 09900
c     Cursor Information
19000 call oppkif
      goto 09900
      end

      subroutine oppksc(*)
c     Peak Search: param=(Hist, Lower, Upper, Width, Threshold [,SetCursor])
      integer*4 prmrd
      character key*80,hstnam*16
      parameter (maxpk=100)
      real*4    peak(maxpk),sgnf(maxpk)
      integer*4 setcsr
      if (prmrd(key,0).ne.0) goto 91000
      call hlkup(key,id,*90000)
      if (prmrd(key,0).ne.0) goto 91000
      read(key,*,err=90000) xmin
      if (prmrd(key,0).ne.0) goto 91000
      read(key,*,err=90000) xmax
      if (prmrd(key,0).ne.0) goto 91000
      read(key,*,err=90000) fwhm
      if (prmrd(key,0).ne.0) goto 91000
      read(key,*,err=90000) thrs
      setcsr=0
      if (prmrd(key,1).ne.0) goto 01000
      read(key,*,err=90000) setcsr
01000 call srchpk(id,xmin,xmax,fwhm,thrs,npeak,peak,sgnf,maxpk,*99000)
      if (npeak.eq.0) goto 89000
      key=hstnam(id)
      write(6,'(A)') '<< RESULT >>'
      write(6,'(2A)') 'Peak Searched in ',key(:length(key))
      call parff2(xmin,xmax,key,l)
      write(6,'(2A)') 'Range = ',key(:l)
      call frefrm(fwhm,key,l)
      write(6,'(2A)') 'FWHM  = ',key(:l)
      call frefrm(thrs,key,l)
      write(6,'(2A)') 'Threshold = ',key(:l)
      write(6,'(A8,8X,A,8X,A)') 'Peak#','Position','Significance'
      do 80100 ipeak=1,npeak
         call frefrm(peak(ipeak),key( 1:16),l)
         call frefrm(sgnf(ipeak),key(17:32),l)
80100    write(6,'(I8,8X,A)') ipeak,key(:l+16)
      write(6,'(A)') '<< EOF >>'
      if (setcsr.ne.0) then
         sgnfmx=thrs
         if (npeak.gt.8) then
            write(6,'(/2X,3A)') 'Peaks found more than 8.  ',char(7),
     &                          'Predominants are set to Cursors.'
            sgnfmx=1.E30
            do 82000 i=1,8
               sgnfmn=thrs
               do 81000 ipeak=1,npeak
81000             if (sgnf(ipeak).gt.sgnfmn.and.
     &                sgnf(ipeak).lt.sgnfmx) sgnfmn=sgnf(ipeak)
82000	       sgnfmx=sgnfmn
         endif
         i=0
         do 83000 ipeak=1,npeak
            if (sgnf(ipeak).ge.sgnfmx) then
               i=i+1
               if (i.le.8) call crsrmn(id,i,2,1,peak(ipeak))
            endif
83000    continue
         do 84000 icrsr=i+1,8
84000       call crsrmn(id,icrsr,2,0,0.)
      endif
      return
89000 write(6,'(A)') 'Peak Not Found.'
      return
90000 i=prmrd(key,1)	! read remaining line
91000 write(6,'(A)') '! Illigal Parameter in Option Peak-Search'
99000 return 1
      end

      subroutine srchpk(id,xmin,xmax,fwhm,thrs,npeak,peak,sgnf,maxpk,*)
      integer*4 id,nd,nb(2),ms,hbinx
      real*4    xmin,xmax,peak(maxpk),sgnf(maxpk),xl(2),xw(2)
      parameter (maxt=1000)
      real*4    y(10000),c(-maxt:maxt),s(-maxt:maxt)
      common /dmycom/y,c,s
      i1=hbinx(amin1(xmin,xmax))
      i2=hbinx(amax1(xmin,xmax))
      if (i1.eq.i2) goto 92000
      call chkcmb(id)
      call clermn(errmin,id)
      call nargset(7)
      call hget(id,'GET ',nd,nb,ms,xl,xw)
      w =fwhm/xw(1)
      it=max(nint(1.1*w),1)
      n =nb(1)
      do 10000 i=1,it
         y(i)=0.
         y(n)=0.
10000    n=n-1
      do 20000 j=0,it
         v=(float(j)/w)**2
         c( j)=exp(-2.75*v)
         c(-j)=c( j)
         s( j)=exp(-2.*v*v)
20000    s(-j)=s( j)
      do 40000 i=it+1,nb(1)-it-1
         g  =0.
         gcy=0.
         gc =0.
         gy =0.
         gcc=0.
         do 30000 j=-it,it
            gw=s(j)/amax1(errmin,hye(i))**2
            g  =g  +gw
            gcy=gcy+gw*c(j)*hy(i+j)
            gc =gc +gw*c(j)
            gy =gy +gw*hy(i+j)
30000       gcc=gcc+gw*c(j)*c(j)
         den  =g*(gcc*g-gc*gc)
         if (den.le.0.) return 3
40000    y(i) =(g*gcy-gc*gy)/sqrt(den)
      k2=int(w*.8+.99)
      npeak=0
      a=y(1)
      d=-1.
      do 50000 i=i1+1,i2
         b= y(i)
         if (a.ge.thrs) then
            if (d.eq.1..and.b.lt.a) then
               if (npeak.eq.0.or.i-k.ge.k2) then
                  npeak=npeak+1
                  if (npeak.gt.maxpk) goto 80000
               else
                  if (y(k).ge.a) goto 45000
               endif
               k=i-1
               peak(npeak)=hx(k)+xw(1)/2.
               sgnf(npeak)=a
            endif
         endif
45000    d=sign(1.,b-a)
50000    a=b
80000 if (npeak.le.maxpk) return
91000 write(6,*) "# Too Many Peak."
      return 1
92000 write(6,*) "# Illigal Range."
      return 1
      end

      subroutine oppkft(*)
c     Peak Fit by Gaussian: param=(Hist, Lower, Upper [,SetCursor, Residue])
      integer*4 prmrd,hbinx,nb(2),setcsr
      character key*80,hstnam*16,rsdnam*16
      real*4    prm(1000),dprm(1000)
      real*4    gpkfnc,gpkset,gpkval,gpkdrv
      external  gpkfnc,gpkset,gpkval,gpkdrv
      data lastid/0/,cond/1.E-5/,maxrpt/500/
      if (prmrd(key,0).ne.0) goto 91000
      call hlkup(key,id,*90000)
      if (prmrd(key,0).ne.0) goto 91000
      read(key,*,err=90000) xmin
      if (prmrd(key,0).ne.0) goto 91000
      read(key,*,err=90000) xmax
      setcsr=0
      rsdnam=' '
      if (prmrd(key,0).ne.0) goto 01000
      read(key,*,err=90000) setcsr
      idmy=prmrd(rsdnam,1)
01000 call gpkpnt(nprm,prm,*99000)
      call curfit(id,xmin,xmax,cond,maxrpt,gpkset,gpkval,gpkdrv,
     &     nprm,prm,dprm,chisqr,nfree,*99000)
      if (lastid.ne.0) call hoptn('RES,NFUNC',0,lastid)
      call hoptn( 'FUNC',gpkfnc,id)
      v=gpknfn(nfunc)
      call hoptn('NFUNC', nfunc,id)
      lastid=id
      key=hstnam(id)
      write(6,'(A)')    '<< RESULT >>'
      write(6,'(2A)') 'Gaussian Peak Fit to ',key(:length(key))
      call parff2(xmin,xmax,key,l)
      write(6,'(2A)')   'Range = ',key(:l)
      write(6,'(A,1pE10.3,A,I5)')
     &                  'Chi**2 =',chisqr,'  Freedom =',nfree
      call oppkfo(id,setcsr,dprm)
      write(6,'(A)')    '<< EOF >>'
      call oppkro
      if (rsdnam.eq.' ') goto 80000
      call crehst(id,idrsd,rsdnam,'E*4 ','Residu',*99000)
      call calrsd(idrsd,id,xmin,xmax,gpkval)
80000 call hlist	! for '*'-mark
81000 return
90000 i=prmrd(key,1)	! read remaining line
91000 write(6,'(A)') '! Illigal Parameter in Option Peak Fit'
      goto 99000
92000 write(6,'(A)') '# Not 1-DIM Histogram.'
99000 return 1
c
      entry oppkco(*)
c     Peak Condition: param=(max-repeat, convergence)
      if (prmrd(key,0).ne.0) goto 91000
      read(key,*,err=90000) maxrpt
      if (prmrd(key,1).ne.0) goto 81000
      read(key,*,err=90000) cond
      goto 81000
      end

      subroutine oppkfo(id,setcsr,dprm)
      integer*4 setcsr
      real*4    dprm(*)
      include 'peak_common.f'
      character string*80,strsub(0:4)*16,hstnam*16
      equivalence (string,strsub)
      character pknam*80,pknamx(0:4)*16
      character plnam*80,plnamx(0:4)*16
      character exnam*48,exnamx(0:2)*16
      character hsnam*48,hsnamx(0:2)*16
      equivalence (pknam,pknamx),(plnam,plnamx),
     &            (exnam,exnamx),(hsnam,hsnamx)
      data pknamx/'Peak#','Amplitude','Centroid','FWHM','Ratio(R/L)'/
      data plnamx/'Poly.-back','X**0','X**1','X**2','X**3'/
      data exnamx/'Exp. -back','Amplitude','X-factor'/
      data hsnamx/'Hist.-back','ID','Amplitude'/
      n=0
10000 do 11000 i=1,maxgpk
         if (.not.cp(i)) goto 11000
         if (n.eq.0) then
            write(6,'(A)') pknam(:length(pknam))
         endif
         n=n+1
         write(strsub(0),'(I6)') n
         do j=1,4
	    call frefrm(wg(i,j),strsub(j),l)
         enddo
         write(6,'(A)') string(:64+l)
         strsub(0)='   sigma'
         do j=1,4
	    if (pg(i,j).eq.0) then
               strsub(j)='-'
            else
               w=dprm(pg(i,j))
               if (j.eq.1.and.sg(i,j).gt.0) w=w*rn(i)
               call frefrm(w,strsub(j),l)
            endif
         enddo
         write(6,'(A)') string(:64+l)
11000 continue
20000 do i=0,nbko
         if (sp(i).ne.0.or.wp(i).ne.0.) goto 21000
      enddo
      goto 30000
21000 write(6,'(A)') plnam(:length(plnam))
      do i=0,nbko
         call frefrm(wp(i),strsub(i),l)
      enddo
      write(6,'(16X,A)') string(:48+l)
      do i=0,nbko
         if (pp(i).eq.0) then
            strsub(i)='-'
         else
            call frefrm(dprm(pp(i)),strsub(i),l)
         endif
      enddo
      write(6,'(A8,8X,A)') 'sigma',string(:48+l)
30000 if (se(1).eq.0.and.we(1).eq.0..and.
     &    se(2).eq.0.and.we(2).eq.0.) goto 40000
      write(6,'(A)') exnam(:length(exnam))
      do i=1,2
         call frefrm(we(i),strsub(i-1),l)
      enddo
      write(6,'(16X,A)') string(:16+l)
      do i=1,2
         if (pe(i).eq.0) then
            strsub(i-1)='-'
         else
            call frefrm(dprm(pe(i)),strsub(i-1),l)
         endif
      enddo
      write(6,'(A8,8X,A)') 'sigma',string(:16+l)
40000 if (sh(1).eq.0) goto 50000
      write(6,'(A)') hsnam(:length(hsnam))
      call frefrm(wh,string,l)
      write(6,'(16X,2A)') hstnam(sh(1)),string(:l)
c     string=hstnam(sh(1))
c     call frefrm(wh,string(17:),l)
c     write(6,'(16X,A)') string(:16+l)
      if (ph.eq.0) then
         string='-'
      else
         call frefrm(dprm(ph),string,l)
      endif
      write(6,'(A8,24X,2A)') 'sigma',string(:l)
50000 if (setcsr.ne.0) then
         do i=1,maxgpk
            if (cp(i)) call crsrmn(id,i,2,1,wm(i))
         enddo
      endif
      return
      end

      subroutine oppkro
      include 'peak_common.f'
      character string*20,ng(4)*10
      data ng/'amplitude','centroid','width','ratio'/
      write(6,'(A)') '<< PEAK_RESULT >>'
      do i=1,8
         if (cp(i)) then
            do j=1,4
               if (sg(i,j).lt.0) then
                  call frefrm(wg(i,j),string,l)
                  write(6,'(A,I1,2A,2A)')
     &                 'set optPeakParameter(',i,',',
     &                 ng(j)(:length(ng(j))),') ',string(:l)
               endif
            enddo
         endif
      enddo
      do i=0,nbko
         if (sp(i).lt.0) then
            call frefrm(wp(i),string,l)
            write(6,'(A,I1,2A)')
     &           'set optPeakPolynomial(',i,') ',string(:l)
         endif
      enddo
      if (se(1).lt.0) then
         call frefrm(we(1),string,l)
         write(6,'(2A)') 'set optPeakExponential(N) ',string(:l)
      endif
      if (se(2).lt.0) then
         call frefrm(we(2),string,l)
         write(6,'(2A)') 'set optPeakExponential(mu) ',string(:l)
      endif
      if (sh(2).lt.0) then
         call frefrm(wh,string,l)
         write(6,'(2A)') 'set optPeakHistogram(factor) ',string(:l)
      endif
      write(6,'(A)') '<< EOF >>'
      return
      end

      subroutine oppkrs(*)
c     reset parameters
      include 'peak_common.f'
      integer*4 prmrd
      character key*80
      do i=1,maxgpk
         cp(i)=.false.
      enddo
      do i=0,nbko
         sp(i)=0
         wp(i)=0.
      enddo
      do i=1,2
         se(i)=0
         we(i)=0.
      enddo
      sh(1)=0
      wh   =1.
      i=prmrd(key,1)	! read remaining line
      return
      end

      subroutine oppkpr(*)
c     Peak Parameter: param=(No. S/F/C amplitude S/F/C centroid 
c                                S/F/C FWHM S/F/C R/L-ratio)
      include 'peak_common.f'
      integer*4 prmrd
      character key*80
      if (prmrd(key,0).ne.0) goto 91000
      read(key,*,err=90000) n
      if (n.le.0.or.n.gt.maxgpk) goto 90000
      cp(n)=.true.
      do i=1,4
         if (prmrd(key,0).ne.0) goto 91000
         call upcase(key,key)
         if      (key.eq.'S') then
            sg(n,i)=-1
            if (prmrd(key,0).ne.0) goto 91000
            read(key,*,err=90000) wg(n,i)
         else if (key.eq.'F') then
            sg(n,i)= 0
            if (prmrd(key,0).ne.0) goto 91000
            read(key,*,err=90000) wg(n,i)
         else if (key.eq.'C') then
            if (prmrd(key,0).ne.0) goto 91000
            read(key,*,err=90000) sg(n,i)
            if (sg(n,i).le.0.or.sg(n,i).gt.maxgpk) goto 90000
         else
            goto 90000
         endif
      enddo
      return
90000 i=prmrd(key,1)	! read remaining line
91000 write(6,'(A)') '! Illigal Parameter in Option Peak-Parameter'
99000 return 1
      end

      subroutine oppkpl(*)
c     Peak Polynomial-Back: param=(S/F 0-th S/F 1-st ...)
      include 'peak_common.f'
      integer*4 prmrd
      character key*80
      do n=0,nbko
         if (prmrd(key,0).ne.0) goto 80000
         call upcase(key,key)
         if      (key.eq.'S') then
            sp(n)=-1
         else if (key.eq.'F') then
            sp(n)= 0
         else
            goto 90000
         endif
         if (prmrd(key,0).ne.0) goto 91000
         read(key,*,err=90000) wp(n)
      enddo
80000 return
90000 i=prmrd(key,1)	! read remaining line
91000 write(6,'(A)') '! Illigal Parameter in Option Peak-Polynomial'
99000 return 1
      end

      subroutine oppkex(*)
c     Peak Exponential-Back: param=(S/F amplitude S/F decay)
      include 'peak_common.f'
      integer*4 prmrd
      character key*80
      do n=1,2
         if (prmrd(key,0).ne.0) goto 91000
         call upcase(key,key)
         if      (key.eq.'S') then
            se(n)=-1
         else if (key.eq.'F') then
            se(n)= 0
         else
            goto 90000
         endif
         if (prmrd(key,0).ne.0) goto 91000
         read(key,*,err=90000) we(n)
      enddo
80000 return
90000 i=prmrd(key,1)	! read remaining line
91000 write(6,'(A)') '! Illigal Parameter in Option Peak-Exponential'
99000 return 1
      end

      subroutine oppkhs(*)
c     Peak Histogram-Back: param=(ID S/F factor)
      include 'peak_common.f'
      integer*4 prmrd
      character key*80
      if (prmrd(key,0).ne.0) goto 91000
      call hlkup(key,sh(1),*90000)
      if (prmrd(key,0).ne.0) goto 91000
      call upcase(key,key)
      if      (key.eq.'S') then
         sh(2)=-1
      else if (key.eq.'F') then
         sh(2)= 0
      else
         goto 90000
      endif
      if (prmrd(key,0).ne.0) goto 91000
      read(key,*,err=90000) wh
      return
90000 i=prmrd(key,1)	! read remaining line
91000 write(6,'(A)') '! Illigal Parameter in Option Peak-Exponential'
99000 return 1
      end

      subroutine oppkif(*)
c     Peak Cursor Information: param=(hist)
      integer*4 prmrd,hbinx
      character key*80
      if (prmrd(key,1).ne.0) goto 91000
      call hlkup(key,id,*91000)
      call nargset(3)
      call hget(id,'GET ',nd)
      if (nd.ne.1) goto 91000
      write(6,'(A)') '<< PEAK_INFO >>'
      do i=1,8
         call crsrmn(id,i,1,istat,x,dmy)
         if (istat.eq.1) then
            call frefrm(x           ,key       ,l1)
            call frefrm(hy(hbinx(x)),key(l1+2:),l2)
            write(6,'(I2,1X,A)') i,key(:l1+l2+1)
         endif
      enddo
      write(6,'(A)') '<< EOF >>'
      return
91000 write(6,'(A)') '! Illigal Parameter in Option Peak Cursor_Info'
99000 return 1
      end

      subroutine gpkpnt(n,prm,*)
      real*4    prm(*)
      include 'peak_common.f'
      n=0
      do 10000 i=0,nbko
10000    pp (i)=0
      do 10100 i=1,2
10100    pe (i)=0
      ph    =0
      do 11000 i=1,maxgpk
         if (.not.cp(i)) goto 11000
         pn (i)=0
         pm (i)=0
         pl (i)=0
         pr (i)=0
11000 continue
      do 20000 i=0,nbko
         if (sp(i).lt.0) then
            n=n+1
            pp (i)=n
            prm(n)=wp(i)
         endif
20000 continue
      do 20100 i=1,2
         if (se(i).lt.0) then
            n=n+1
            pe (i)=n
            prm(n)=we(i)
         endif
20100 continue
      if (sh(1).ne.0.and.sh(2).ne.0) then
         n=n+1
         ph    =n
         prm(n)=wh
      endif
      do 28000 i=1,maxgpk
         if (.not.cp(i)) goto 28000
         if (sn(i).lt.0) then
            n=n+1
            pn (i)=n
            prm(n)=wn(i)
            do 21000 j=i+1,maxgpk
               if (cp(j).and.sn(j).eq.i) then
                  pn(j)=n
                  rn(j)=wn(j)/wn(i)
               endif
21000       continue
         else if (sn(i).gt.0) then
            if (.not.cp(sn(i))) goto 92000
         endif
         if (sm(i).lt.0) then
            n=n+1
            pm (i)=n
            prm(n)=wm(i)
            do 22000 j=i+1,maxgpk
22000          if (cp(j).and.sm(j).eq.i) pm(j)=n
	 else if (sm(i).gt.0) then
            if (.not.cp(sm(i))) goto 92000
         endif
         if (sl(i).lt.0) then
            n=n+1
            pl (i)=n
            prm(n)=wl(i)
            do 23000 j=i+1,maxgpk
23000          if (cp(j).and.sl(j).eq.i) pl(j)=n
	 else if (sl(i).gt.0) then
            if (.not.cp(sl(i))) goto 92000
         endif
         if (sr(i).lt.0) then
            n=n+1
            pr (i)=n
            prm(n)=wr(i)
            do 24000 j=i+1,maxgpk
24000          if (cp(j).and.sr(j).eq.i) pr(j)=n
	 else if (sr(i).gt.0) then
            if (.not.cp(sr(i))) goto 92000
         endif
         do 25000 j=1,i-1
	    if (sn(i).eq.j) wn(i)=wn(j)
	    if (sm(i).eq.j) wm(i)=wm(j)
	    if (sl(i).eq.j) wl(i)=wl(j)
25000	    if (sr(i).eq.j) wr(i)=wr(j)
28000 continue
      if (n.eq.0) goto 91000
      return
91000 write(6,'(A)') '# No Search Parameter'
      return 1
92000 write(6,'(A)') '# Param. Common to Invalid Peak'
      return 1
      end

      function gpkset(prm,nprm)
      real*4    prm(nprm)
      include 'peak_common.f'
      do 10000 i=0,nbko
10000    if (pp(i).ne.0) wp(i)=      prm(pp(i))
      do 10100 i=1,2
10100    if (pe(i).ne.0) we(i)=      prm(pe(i))
      if (ph   .ne.0) wh   =amax1(prm(ph   ),0.)
      do 20000 i=1,maxgpk
         if (.not.cp(i)) goto 20000
         if (pn(i).ne.0) wn(i)=amax1(prm(pn(i)),0.)
         if (pm(i).ne.0) wm(i)=      prm(pm(i))
         if (pl(i).ne.0) wl(i)=amax1(prm(pl(i)),1.E-10)
         if (pr(i).ne.0) wr(i)=amax1(prm(pr(i)),1.E-10)
         if (sn(i).gt.0) wn(i)=wn(sn(i))*rn(i)
20000 continue
      gpkset=0
      return
      end

      function gpkfnc(x,i)
      include 'peak_common.f'
      parameter (sig2fw=2.35482)	! 2*sqrt(2*ln(2))
      integer*4 nfunc,fncpnt(maxgpk+2),hbinx,nb(2)
      real*4    xl(2),xw(2)
      if        (i.eq.nfunc) then
         gpkfnc=gpkval(x)
      else if (i.eq.nfunc-1) then
         gpkfnc=wp(0)+x*(wp(1)+x*(wp(2)+x*wp(3)))
     &         +we(1)*exp(amin1(we(2)*x,50.))
         if (sh(1).ne.0) then
            call nargset(7)
            call hget(sh(1),'GET ',nd,nb,ms,xl,xw)
            gpkfnc=gpkfnc
     &            +wh*hy(hbinx(amax1(xl(1),amin1(xw(1)*nb(1),x))))
         endif
      else
         w=(x-wm(fncpnt(i)))/wl(fncpnt(i))*sig2fw
         if (w.gt.0.) w=w/wr(fncpnt(i))
         gpkfnc=wn(fncpnt(i))*exp(-w*w/2.)
      endif
      return
      entry gpknfn(n)
      nfunc=0
      do 20000 j=1,maxgpk
         if (.not.cp(j)) goto 20000
         nfunc =nfunc+1
         fncpnt(nfunc)=j
20000 continue
      nfunc=nfunc+2
      n=nfunc
      end

      function gpkval(x)
      include 'peak_common.f'
      integer*4 hbinx,nb(2)
      real*4    xl(2),xw(2)
      parameter (sig2fw=2.35482)	! 2*sqrt(2*ln(2))
      gpkval=wp(0)+x*(wp(1)+x*(wp(2)+x*wp(3)))
     &      +we(1)*exp(amin1(we(2)*x,50.))
      if (sh(1).ne.0) then
         call nargset(7)
         call hget(sh(1),'GET ',nd,nb,ms,xl,xw)
         gpkval=gpkval
     &         +wh*hy(hbinx(amax1(xl(1),amin1(xw(1)*nb(1),x))))
      endif
      do 10000 j=1,maxgpk
         if (.not.cp(j)) goto 10000
         w=(x-wm(j))/wl(j)*sig2fw
         if (w.gt.0.) w=w/wr(j)
         gpkval=gpkval+wn(j)*exp(-w*w/2.)
10000 continue
      return
      end

      function gpkdrv(x,derive,nprm)
      real*4    x,derive(nprm)
      include 'peak_common.f'
      integer*4 hbinx,nb(2)
      real*4    xl(2),xw(2)
      parameter (sig2fw=2.35482)	! 2*sqrt(2*ln(2))
      do 10000 j=1,nprm
10000    derive(j)=0.
      v=1.
      do 20000 j=0,nbko
         if (pp(j).ne.0) derive(pp(j))=v
20000    v=v*x
      if (pe(1).ne.0) derive(pe(1))=exp(amin1(we(2)*x,50.))
      if (pe(2).ne.0) derive(pe(2))=exp(amin1(we(2)*x,50.))*we(1)*x
      if (ph   .ne.0) then
         call nargset(7)
         call hget(sh(1),'GET ',nd,nb,ms,xl,xw)
         derive(ph)=hy(hbinx(amax1(xl(1),amin1(xw(1)*nb(1),x))))
      endif
      do 30000 j=1,maxgpk
         if (.not.cp(j)) goto 30000
         w1=(x-wm(j))
         w2=wl(j)/sig2fw
         if (w1.gt.0.) w2=w2*wr(j)
         w3=w1/w2
         v =exp(-w3*w3/2.)
         if (pn(j).ne.0) then
            if (sn(j).lt.0) then
               derive(pn(j))=derive(pn(j))+v
            else
               derive(pn(j))=derive(pn(j))+v*rn(j)
            endif
         endif
         v =wn(j)*v*w3/w2
         if (pm(j).ne.0) derive(pm(j))=derive(pm(j))+v
         if (pl(j).ne.0) derive(pl(j))=derive(pl(j))+v*w1/wl(j)*sig2fw
         if (pr(j).ne.0.and.w1.gt.0.)
     &                   derive(pr(j))=derive(pr(j))+v*w1/wr(j)
30000 continue
      gpkdrv=0.
      return
      end

      block data gpkini
      include 'peak_common.f'
      parameter (mxgpk1=maxgpk-1, nbk1=nbko+1)
      data cp/maxgpk*.false./
      data sn/maxgpk*-1/,sm/maxgpk*-1/,
     &     sl/maxgpk*-1/,sr/maxgpk* 0/,
     &     sp/nbk1*0/,se/2*0/,sh/2*0/
      data wn/maxgpk*100./,wm/maxgpk*0./,wl/maxgpk*.1/,wr/maxgpk*1./,
     &     wp/nbk1*0./,we/2*0./,wh/0./
      end
